import React from 'react';
import { defaultProps } from './props/defaultProps';
import { propTypes } from './props/propTypes';
import style from './Buttongroup.module.css';
/* eslint css-modules/no-unused-class: [2, { markAsUsed: ['footer','header',
'tab','alignleft','alignright','aligncenter' ] }] */

export default class Buttongroup extends React.Component {
  render() {
    let {
      children,
      type,
      buttonPosition,
      customClass,
      dataId,
      dataSelectorId
    } = this.props;
    let btnGroup = [];
    children && children.forEach(child => {
      let btnRight = /*#__PURE__*/React.createElement("span", {
        className: style[type]
      }, child);
      btnGroup.push(btnRight);
    });
    return /*#__PURE__*/React.createElement("div", {
      className: `${style.buttonGroup} ${style[type]} ${customClass ? customClass : ''}`,
      "data-id": dataId,
      "data-test-id": dataId,
      "data-selector-id": dataSelectorId
    }, /*#__PURE__*/React.createElement("div", {
      className: style[`align${buttonPosition}`]
    }, children));
  }

}
Buttongroup.defaultProps = defaultProps;
Buttongroup.propTypes = propTypes; // if (__DOCS__) {
//   Buttongroup.docs = {
//     componentGroup: 'Molecule',
//     folderName: 'Style Guide',
//     external: false,
//     description: ' ',
//     images: [
//       {
//         view: 'http://zsupport-tech-1.tsi.zohocorpin.com:8080/ui/general/ButtonGroup/v1/ButtonGroup.png',
//         psd: 'http://zsupport-tech-1.tsi.zohocorpin.com:8080/ui/general/ButtonGroup/v1/ButtonGroup.psd'
//       }
//     ]
//   };
// }