// Date Pattern Letters And its Meanings :-
// 1. d/D: day without 0 prefix on single digit.
// 2. dd/DD: day with 0 prefix if single digit.
// 3. M: Month without 0 prefix on single digit.
// 4. MM: Month with 0 prefix if single digit.
// 5. yy/YY: Last two digit of year.
// 6. yyyy/YYYY: represents full year.
// 7. HH: 24 hour based hour. ie. 13:00. **H** will display hour without prefix 0 if single digit
// 8. hh: 12 hour based hour. ie. 01:00. **h** will display hour without prefix 0 if single digit
// 9. m: minute without 0 prefix on single digit.
// 10.mm: minute with 0 prefix if single digit.
// 11.s: second without 0 prefix on single digit.
// 12.ss: second with 0 prefix if single digit.
// 13.S: milliseconds with 0 prefix if single digit.
// 14.a: represent the AM or PM
// 15.A: represent the AM or PM
// 16.Z: represent the timezone (Asia/Kolkata)
// 17. (O) : Offset Of the timezone (GMT+00:00)
export const dateSymbols = {
  d: 'date',
  dd: 'date',
  DD: 'date',
  M: 'month',
  MM: 'month',
  yy: 'year',
  YY: 'year',
  YYYY: 'year',
  yyyy: 'year',
  h: 'hour',
  hh: 'hour',
  H: 'hour',
  HH: 'hour',
  m: 'minute',
  mm: 'minute',
  s: 'second',
  ss: 'second',
  S: 'millisecond',
  a: 'AMPM',
  Z: 'timezone',
  O: 'offset'
};
export const dataFormatList = ['yyyy/MM/dd', 'yyyy-MM-dd', 'yyyy.MM.dd', 'yyyy MM dd', 'MM/dd/yyyy', 'MM-dd-yyyy', 'MM.dd.yyyy', 'MM dd yyyy', 'dd/MM/yyyy', 'dd-MM-yyyy', 'dd.MM.yyyy', 'dd MM yyyy', 'yyyy/MMM/dd', 'yyyy-MMM-dd', 'yyyy.MMM.dd', 'yyyy MMM dd', 'MMM/dd/yyyy', 'MMM-dd-yyyy', 'MMM.dd.yyyy', 'MMM dd yyyy', 'dd/MMM/yyyy', 'dd-MMM-yyyy', 'dd.MMM.yyyy', 'dd MMM yyyy', 'dd/MMMM/yyyy', 'dd-MMMM-yyyy', 'dd-MMMM-yyyy', 'dd MMMM yyyy', 'MMMM/dd/yyyy', 'MMMM-dd-yyyy', 'MMMM.dd.yyyy', 'MMMM dd yyyy', 'yyyy/MMMM/dd', 'yyyy-MMMM-dd', 'yyyy.MMMM.dd', 'yyyy MMMM dd', 'dd/MM/YY', 'dd-MM-YY', 'dd.MM.YY', 'dd MM YY', 'MM/dd/YY', 'MM-dd-YY', 'MM.dd.YY', 'MM dd YY', 'YY/MM/dd', 'YY-MM-dd', 'YY.MM.dd', 'YY MM dd', 'dd/MMM/YY', 'dd-MMM-YY', 'dd.MMM.YY', 'dd MMM YY', 'MMM/dd/YY', 'MMM-dd-YY', 'MMM.dd.YY', 'MMM dd YY', 'YY/MMM/dd', 'YY-MMM-dd', 'YY.MMM.dd', 'YY MMM dd', 'dd/MMMM/YY', 'dd-MMMM-YY', 'dd.MMMM.YY', 'dd MMMM YY', 'MMMM/dd/YY', 'MMMM-dd-YY', 'MMMM.dd.YY', 'MMMM dd YY', 'YY/MMMM/dd', 'YY-MMMM-dd', 'YY.MMMM.dd', 'YY MMMM dd'];