import { useContext } from 'react';
import LibraryContext from '../../../Provider/LibraryContextInit';
import { compileClassNames } from '@zohodesk/utils';
export default function cssJSLogic(_ref) {
  let {
    props,
    style,
    customState
  } = _ref;
  const DropBoxElementContext = useContext(LibraryContext);
  const {
    boxPosition,
    boxDirection,
    boxstyle,
    needBoxStyle,
    isAbsolute
  } = customState;
  const {
    isReducedMotion
  } = DropBoxElementContext || {};
  const {
    isAnimate,
    isArrow,
    size,
    isRadius,
    animationStyle,
    isActive,
    isModel,
    isBoxPaddingNeed,
    isPadding,
    customClass,
    positionsOffset,
    targetOffset,
    zIndexStyle,
    customInlineStyle
  } = props;
  const {
    customDropBox = '',
    customMobileDropBox = '',
    customDropBoxWrap = '',
    customMobileDropBoxWrap = ''
  } = customClass;
  const animationValue = animationStyle === 'default' ? 'fadeInScale' : animationStyle; // const {needBoxStyle,boxstyle} = useDropboxPosCalc(props)

  let boxClassName = compileClassNames({
    [style.main]: true,
    [style.hidden]: !isActive,
    [style.responsive]: !!isModel,
    [customMobileDropBoxWrap]: !!isModel,
    [customDropBoxWrap]: !isModel,
    [style.container]: isAbsolute && !isModel,
    [style[boxPosition]]: isAbsolute && !isModel,
    [style.fixedContainer]: !isAbsolute && !isModel,
    [style[size]]: size && !isModel,
    [style[boxDirection]]: !isModel && isActive && isArrow,
    [style[`arrow${boxDirection}`]]: !isModel && isActive && isArrow && isAbsolute,
    [style[`paddingSpace_${boxDirection}`]]: !isModel && isActive && !isArrow && isPadding
  });
  let subContainerClass = compileClassNames({
    [style.subContainer]: true,
    [customMobileDropBox]: !!isModel,
    [style.mobRadius]: !!isModel,
    [style.slideUp]: !!isModel && isActive,
    [customDropBox]: !isModel,
    [style[`${boxDirection}_shadow`]]: !isModel,
    [style.boxPadding]: !isModel && isBoxPaddingNeed,
    [style.radius]: !isModel && isRadius,
    [style[animationValue]]: !isModel && isAnimate && !isReducedMotion && isActive && !!animationStyle
  });
  let inlineStyle = !isModel ? isAbsolute ? needBoxStyle && boxstyle : positionsOffset && positionsOffset[boxPosition] || {} : {};

  if (zIndexStyle) {
    inlineStyle = Object.assign({}, inlineStyle, zIndexStyle);
  }

  if (!isModel && !isAbsolute && size === 'default' && targetOffset && isActive) {
    inlineStyle = Object.assign({}, inlineStyle, {
      width: targetOffset.width
    });
  }

  if (customInlineStyle) {
    inlineStyle = Object.assign({}, inlineStyle, customInlineStyle);
  }

  return {
    boxClassName,
    subContainerClass,
    inlineStyle
  };
}