import PropTypes from 'prop-types';
export const ListContainer_Props = {
  active: PropTypes.bool,
  autoHover: PropTypes.bool,
  children: PropTypes.node,
  dataId: PropTypes.string,
  dataSelectorId: PropTypes.string,
  disableTitle: PropTypes.string,
  highlight: PropTypes.bool,
  href: PropTypes.string,
  isDisabled: PropTypes.bool,
  isLink: PropTypes.bool,
  needBorder: PropTypes.bool,
  needTick: PropTypes.bool,
  onClick: PropTypes.func,
  onMouseEnter: PropTypes.func,
  onMouseOver: PropTypes.func,
  palette: PropTypes.oneOf(['default', 'primary', 'secondary', 'dark']),
  size: PropTypes.oneOf(['small', 'medium', 'large']),
  target: PropTypes.oneOf(['blank', 'self']),
  title: PropTypes.string,
  a11y: PropTypes.shape({
    role: PropTypes.string,
    ariaSelected: PropTypes.bool
  }),
  customClass: PropTypes.string,
  customProps: PropTypes.object,
  eleRef: PropTypes.func
};
export const ListItem_Props = {
  active: PropTypes.bool,
  autoHover: PropTypes.bool,
  children: PropTypes.node,
  dataId: PropTypes.string,
  dataSelectorId: PropTypes.string,
  disableTitle: PropTypes.string,
  getRef: PropTypes.func,
  highlight: PropTypes.bool,
  href: PropTypes.string,
  id: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  index: PropTypes.number,
  isDisabled: PropTypes.bool,
  isLink: PropTypes.bool,
  needBorder: PropTypes.bool,
  needTick: PropTypes.bool,
  onClick: PropTypes.func,
  onMouseEnter: PropTypes.func,
  palette: PropTypes.oneOf(['default', 'primary', 'secondary', 'dark']),
  size: PropTypes.oneOf(['small', 'medium', 'large']),
  target: PropTypes.oneOf(['blank', 'self']),
  title: PropTypes.string,
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]).isRequired,
  a11y: PropTypes.shape({
    role: PropTypes.string,
    ariaSelected: PropTypes.bool
  }),
  needMultiLineText: PropTypes.bool,
  customClass: PropTypes.shape({
    customListItem: PropTypes.string,
    customTickIcon: PropTypes.string
  }),
  customProps: PropTypes.shape({
    ListItemProps: PropTypes.object
  })
};
export const ListItemWithAvatar_Props = {
  active: PropTypes.bool,
  autoHover: PropTypes.bool,
  avatarPalette: PropTypes.string,
  avatarPalette: PropTypes.string,
  dataId: PropTypes.string,
  dataSelectorId: PropTypes.string,
  disableTitle: PropTypes.string,
  getRef: PropTypes.func,
  highlight: PropTypes.bool,
  id: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  imgSrc: PropTypes.string,
  index: PropTypes.number,
  initial: PropTypes.string,
  isDisabled: PropTypes.bool,
  isTeam: PropTypes.bool,
  name: PropTypes.string,
  needAvatarTitle: PropTypes.bool,
  needBorder: PropTypes.bool,
  needTick: PropTypes.bool,
  onClick: PropTypes.func,
  onMouseEnter: PropTypes.func,
  palette: PropTypes.oneOf(['dark']),
  size: PropTypes.string,
  title: PropTypes.string,
  value: PropTypes.string,
  a11y: PropTypes.shape({
    role: PropTypes.string,
    ariaSelected: PropTypes.bool,
    ariaHidden: PropTypes.bool
  }),
  customClass: PropTypes.shape({
    customListItem: PropTypes.string,
    customAvatar: PropTypes.string,
    customAvatarTeam: PropTypes.string
  }),
  needMultiLineText: PropTypes.bool,
  customProps: PropTypes.shape({
    ListItemProps: PropTypes.object
  })
};
export const ListItemWithCheckBox_Props = {
  active: PropTypes.bool,
  autoHover: PropTypes.bool,
  checked: PropTypes.bool,
  dataId: PropTypes.string,
  dataSelectorId: PropTypes.string,
  disableTitle: PropTypes.string,
  getRef: PropTypes.func,
  highlight: PropTypes.bool,
  id: PropTypes.string,
  index: PropTypes.string,
  isDisabled: PropTypes.bool,
  onClick: PropTypes.func,
  onHover: PropTypes.func,
  palette: PropTypes.string,
  size: PropTypes.string,
  title: PropTypes.string,
  value: PropTypes.string,
  a11y: PropTypes.shape({
    role: PropTypes.string,
    ariaSelected: PropTypes.bool
  }),
  needMultiLineText: PropTypes.bool,
  customClass: PropTypes.shape({
    customListItem: PropTypes.string,
    customCheckBox: PropTypes.string,
    customLabel: PropTypes.string
  }),
  customProps: PropTypes.object
};
export const ListItemWithIcon_Props = {
  active: PropTypes.bool,
  autoHover: PropTypes.bool,
  dataId: PropTypes.string,
  dataSelectorId: PropTypes.string,
  disableTitle: PropTypes.string,
  getRef: PropTypes.func,
  highlight: PropTypes.bool,
  iconClass: PropTypes.string,
  iconName: PropTypes.string,
  iconSize: PropTypes.string,
  id: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  index: PropTypes.number,
  isDisabled: PropTypes.bool,
  needBorder: PropTypes.bool,
  needTick: PropTypes.bool,
  onClick: PropTypes.func,
  onMouseEnter: PropTypes.func,
  palette: PropTypes.string,
  size: PropTypes.string,
  title: PropTypes.string,
  value: PropTypes.string,
  a11y: PropTypes.shape({
    role: PropTypes.string,
    ariaSelected: PropTypes.bool,
    ariaHidden: PropTypes.bool
  }),
  needMultiLineText: PropTypes.bool,
  customClass: PropTypes.string,
  customProps: PropTypes.shape({
    ListItemProps: PropTypes.object
  }),
  isLink: PropTypes.bool,
  href: PropTypes.string,
  target: PropTypes.string
};
export const ListItemWithRadio_Props = {
  active: PropTypes.bool,
  autoHover: PropTypes.bool,
  checked: PropTypes.bool,
  dataId: PropTypes.string,
  dataSelectorId: PropTypes.string,
  disableTitle: PropTypes.string,
  getRef: PropTypes.func,
  highlight: PropTypes.bool,
  id: PropTypes.string,
  index: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  isDisabled: PropTypes.bool,
  onClick: PropTypes.func,
  onHover: PropTypes.func,
  palette: PropTypes.string,
  size: PropTypes.string,
  title: PropTypes.string,
  value: PropTypes.string,
  a11y: PropTypes.shape({
    role: PropTypes.string,
    ariaSelected: PropTypes.bool
  }),
  needMultiLineText: PropTypes.bool,
  customClass: PropTypes.shape({
    customListItem: PropTypes.string,
    customRadio: PropTypes.string,
    customRadioWrap: PropTypes.string
  }),
  customProps: PropTypes.object
};