function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

/**** Libraries ****/
import React from 'react';
import { MultiSelectWithAvatar_propTypes } from './props/propTypes';
import { MultiSelectWithAvatar_defaultProps } from './props/defaultProps';
import { defaultProps as MobileHeader_defaultProps } from './MobileHeader/props/defaultProps';
/**** Components ****/

import { MultiSelectComponent } from './MultiSelect';
import Popup from '../Popup/Popup';
import { Container, Box } from '../Layout';
import Card, { CardContent, CardHeader } from '../Card/Card';
import Suggestions from './Suggestions';
import EmptyState from './EmptyState';
import CssProvider from '../Provider/CssProvider';
import { getUniqueId } from '../Provider/IdProvider';
import ResponsiveDropBox from '../ResponsiveDropBox/ResponsiveDropBox';
import { ResponsiveReceiver } from '../Responsive/CustomResponsive';
import Loader from '@zohodesk/svg/lib/Loader/Loader';
import MultiSelectHeader from './MultiSelectHeader';
/**** CSS ****/

import style from './MultiSelect.module.css';
import MobileHeader from './MobileHeader/MobileHeader';
/*eslint-disable  react/sort-prop-types*/

/* eslint-disable react/forbid-component-props */

/* eslint-disable react/no-unused-prop-types */

class MultiSelectWithAvatarComponent extends MultiSelectComponent {
  constructor(props) {
    super(props);
    this.handleFormatOptions = this.handleFormatOptions.bind(this);
    this.getNextAriaId = getUniqueId(this);
  }

  handleFormatOptions(props) {
    const {
      options,
      valueField,
      textField,
      imageField,
      disabledOptions
    } = props;
    return this.formatOptions({
      options,
      valueField,
      textField,
      imageField,
      optionType: 'avatar',
      disabledOptions
    });
  }

  responsiveFunc(_ref) {
    let {
      mediaQueryOR
    } = _ref;
    return {
      tabletMode: mediaQueryOR([{
        maxWidth: 700
      }])
    };
  }

  render() {
    let {
      isReadOnly,
      needSelectAll,
      searchEmptyMessage,
      emptyMessage,
      noMoreOptionsMessage,
      dropBoxSize,
      isPopupOpen,
      isPopupReady,
      position,
      defaultDropBoxPosition,
      selectAllText,
      getContainerRef,
      removeClose,
      isAnimate,
      animationStyle,
      isDisabled,
      title,
      dataId,
      dataSelectorId,
      needResponsive,
      borderColor,
      disableAction,
      palette,
      i18nKeys,
      isBoxPaddingNeed,
      needEffect,
      isLoading,
      keepSelectedOptions,
      customProps
    } = this.props;
    let {
      SuggestionsProps = {}
    } = customProps;
    i18nKeys = Object.assign({}, MobileHeader_defaultProps.i18nKeys, i18nKeys, {
      emptyText: i18nKeys.emptyText || emptyMessage,
      searchEmptyText: i18nKeys.searchEmptyText || searchEmptyMessage,
      noMoreText: i18nKeys.noMoreText || noMoreOptionsMessage
    });
    const {
      selectedOptions,
      searchStr,
      hoverOption,
      options,
      isFetchingOptions,
      selectedOptionIds
    } = this.state;
    const suggestions = this.handleFilterSuggestions();
    const setAriaId = this.getNextAriaId();
    const ariaErrorId = this.getNextAriaId();
    const popUpState = !isReadOnly && !isDisabled && !disableAction && isPopupOpen;
    return /*#__PURE__*/React.createElement("div", {
      className: ` ${style.wrapper} ${isDisabled ? style.disabled : ''} ${isReadOnly ? style.readOnly : ''} ${disableAction ? CssProvider('isBlock') : ''} ${borderColor === 'transparent' ? style.transparentContainer : ''} ${needEffect && !(isDisabled || isReadOnly) ? style.effect : ''}`,
      "data-id": `${isDisabled ? `${dataId}_disabled` : isReadOnly ? `${dataId}_readOnly` : dataId}`,
      "data-test-id": `${isDisabled ? `${dataId}_disabled` : isReadOnly ? `${dataId}_readOnly` : dataId}`,
      "data-title": isDisabled ? title : null,
      onClick: this.handleInputFocus,
      "data-selector-id": dataSelectorId
    }, this.getSelectionUI(), popUpState ? /*#__PURE__*/React.createElement(ResponsiveReceiver, {
      query: this.responsiveFunc,
      responsiveId: "Helmet"
    }, _ref2 => {
      let {
        tabletMode
      } = _ref2;
      return /*#__PURE__*/React.createElement(ResponsiveDropBox, {
        animationStyle: animationStyle,
        boxPosition: position || `${defaultDropBoxPosition}Center`,
        getRef: getContainerRef,
        isActive: isPopupReady,
        isAnimate: isAnimate,
        isArrow: false,
        onClick: removeClose,
        needResponsive: needResponsive,
        isPadding: false,
        isBoxPaddingNeed: isBoxPaddingNeed,
        palette: palette,
        htmlId: setAriaId,
        a11y: {
          ariaMultiselectable: true,
          role: 'listbox'
        },
        isResponsivePadding: true,
        alignBox: "row"
      }, /*#__PURE__*/React.createElement(Box, {
        flexible: true
      }, /*#__PURE__*/React.createElement(Card, {
        customClass: `${style.box} ${style[`${palette}Box`]}`,
        onScroll: this.handleScroll
      }, tabletMode && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(MobileHeader, {
        selectedOptions: selectedOptions,
        i18nKeys: i18nKeys,
        onClick: this.handlePopupClose
      }, /*#__PURE__*/React.createElement("div", {
        className: style.effect
      }, this.getSelectionUI(true)))), needSelectAll ? /*#__PURE__*/React.createElement(CardHeader, null, /*#__PURE__*/React.createElement(MultiSelectHeader, {
        onSelect: this.handleSelectAll,
        selectAllText: selectAllText,
        suggestions: suggestions,
        dataId: dataId
      })) : null, isLoading ? /*#__PURE__*/React.createElement(Container, {
        align: "both",
        className: style.loader
      }, /*#__PURE__*/React.createElement(Loader, null)) : /*#__PURE__*/React.createElement(CardContent, {
        shrink: true,
        customClass: !tabletMode && dropBoxSize ? style[dropBoxSize] : '',
        eleRef: this.suggestionContainerRef
      }, suggestions.length ? /*#__PURE__*/React.createElement(Suggestions, _extends({
        needTick: keepSelectedOptions,
        suggestions: suggestions,
        getRef: this.suggestionItemRef,
        hoverOption: hoverOption,
        onClick: this.handleSelectOption,
        onMouseEnter: this.handleMouseEnter,
        needBorder: false,
        dataId: `${dataId}_Options`,
        palette: palette,
        selectedOptions: selectedOptionIds,
        a11y: {
          role: 'option'
        }
      }, SuggestionsProps)) : /*#__PURE__*/React.createElement(EmptyState, {
        isLoading: isFetchingOptions,
        options: options,
        searchString: searchStr,
        suggestions: suggestions,
        dataId: dataId,
        palette: palette,
        i18nKeys: i18nKeys,
        htmlId: ariaErrorId
      }), isFetchingOptions && /*#__PURE__*/React.createElement(Container, {
        isCover: false,
        align: "both"
      }, /*#__PURE__*/React.createElement(Loader, null))))));
    }) : null);
  }

}

MultiSelectWithAvatarComponent.propTypes = MultiSelectWithAvatar_propTypes;
MultiSelectWithAvatarComponent.defaultProps = MultiSelectWithAvatar_defaultProps;
MultiSelectWithAvatarComponent.displayName = 'MultiSelectWithAvatar';
const MultiSelectWithAvatar = Popup(MultiSelectWithAvatarComponent);
MultiSelectWithAvatar.defaultProps = MultiSelectWithAvatarComponent.defaultProps;
MultiSelectWithAvatar.propTypes = MultiSelectWithAvatarComponent.propTypes;
export default MultiSelectWithAvatar;