import { useNumberGenerator, getNumberGenerators } from './NumberGenerator/NumberGenerator';
import { getLibraryConfig } from './Config';
let globalId = getLibraryConfig('idCounter'),
    deletedIndexes = [],
    globalPrefix;
export function setGlobalIdPrefix(value) {
  globalPrefix = value;
}
export function removeGlobalIdPrefix() {
  globalPrefix = undefined;
}

function getGlobalIdPrefix() {
  return globalPrefix;
}

function setGlobalId(id) {
  globalId = id;
}

function getGlobalId() {
  return globalId;
}

function setDeletedIndexes(array) {
  deletedIndexes = array;
}

function getDeletedIndexes() {
  return deletedIndexes;
}

function callback(_ref) {
  let {
    globalId,
    deletedIndexes
  } = _ref;
  setGlobalId(globalId);
  setDeletedIndexes(deletedIndexes);
}

export function useUniqueId(prefix) {
  return useNumberGenerator({
    getGlobalId,
    prefix,
    getGlobalPrefix: getGlobalIdPrefix,
    getDeletedIndexes,
    callback
  });
}
export function getUniqueId(Component, prefix) {
  return getNumberGenerators({
    Component,
    prefix,
    getGlobalPrefix: getGlobalIdPrefix,
    getGlobalId,
    getDeletedIndexes,
    callback
  });
} // let Provider = {
//   docs: {
//     componentGroup: 'Provider',
//     folderName: 'Functions'
//   }
// };
// export { Provider };