function isSame(a, b) {
  return a === b;
}

const {
  hasOwnProperty
} = Object.prototype;
export default function shallowCompare(objA, objB) {
  if (objA && objB && typeof objA === 'object' && typeof objB === 'object') {
    const keysA = Object.keys(objA);
    const keysB = Object.keys(objB);

    if (keysA.length !== keysB.length) {
      return false;
    } // Test for A's keys different from B.


    for (let key of keysA) {
      if (!hasOwnProperty.call(objB, key) || !isSame(objA[key], objB[key])) {
        return false;
      }
    }

    return true;
  }

  return isSame(objA, objB);
}