import React from 'react';
import { render } from '@testing-library/react';
import Ribbon from '../Ribbon.js';
describe('Label', () => {
  test('rendering the defult props', () => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(Ribbon, null));
    expect(asFragment()).toMatchSnapshot();
  });
  const palette = ['default', 'danger', 'primary', 'secondary', 'info', 'dark'];
  test.each(palette)('rendering the palette of- %s', palette => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(Ribbon, {
      palette: palette
    }));
    expect(asFragment()).toMatchSnapshot();
  });
  const type = ['default', 'flag', 'plain', 'ribbon', 'box', 'stamp', 'sticker', 'tag'];
  test.each(type)('rendering the type - %s', type => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(Ribbon, {
      type: type
    }));
    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering children ', () => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(Ribbon, null, /*#__PURE__*/React.createElement("span", null, " Ribbon 1 ")));
    expect(asFragment()).toMatchSnapshot();
  });
  const size = ['small', 'medium', 'large', 'xlarge'];
  test.each(size)('rendering the size - %s', size => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(Ribbon, {
      size: size
    }));
    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the customClass', () => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(Ribbon, {
      customClass: "ribbonCustomClass"
    }));
    expect(asFragment()).toMatchSnapshot();
  });
});