import React from 'react';
import { render } from '@testing-library/react';
import RippleEffect from '../RippleEffect.js';
describe('RippleEffect', () => {
  test('rendering the defult props', () => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(RippleEffect, null, /*#__PURE__*/React.createElement("div", null, "RippleEffect")));
    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering isActive is true', () => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(RippleEffect, {
      isActive: true
    }, /*#__PURE__*/React.createElement("div", null, "RippleEffect")));
    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering isDisabled is true', () => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(RippleEffect, {
      isDisabled: true
    }, /*#__PURE__*/React.createElement("div", null, "RippleEffect")));
    expect(asFragment()).toMatchSnapshot();
  });
  const palette = ['default', 'primary', 'primaryLight', 'primaryFilled', 'primaryDark', 'green', 'danger'];
  test.each(palette)('rendering the palette of- %s', palette => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(RippleEffect, {
      palette: palette
    }, /*#__PURE__*/React.createElement("div", null, "RippleEffect")));
    expect(asFragment()).toMatchSnapshot();
  });
  const hoverTypes = ['default', 'border', 'bg', 'test'];
  test.each(hoverTypes)('rendering hoverType of- %s', hoverType => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(RippleEffect, {
      hoverType: hoverType
    }, /*#__PURE__*/React.createElement("div", null, "RippleEffect")));
    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering isNeedEffect is false', () => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(RippleEffect, {
      isNeedEffect: false
    }, /*#__PURE__*/React.createElement("div", null, "RippleEffect")));
    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering needBorder is false', () => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(RippleEffect, {
      needBorder: false
    }, /*#__PURE__*/React.createElement("div", null, "RippleEffect")));
    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering isCopyTextEnabled is false', () => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(RippleEffect, {
      isCopyTextEnabled: true
    }, /*#__PURE__*/React.createElement("div", null, "RippleEffect")));
    expect(asFragment()).toMatchSnapshot();
  });
});