import PropTypes from 'prop-types';
import { propTypes as TextBox_propTypes } from '../../TextBox/props/propTypes';
export const propTypes = { ...TextBox_propTypes,
  borderColor: PropTypes.oneOf(['transparent', 'default', 'error']),
  children: PropTypes.node,
  dataId: PropTypes.string,
  dataSelectorId: PropTypes.string,
  htmlId: PropTypes.string,
  i18nKeys: PropTypes.shape({
    clearText: PropTypes.string
  }),
  iconRotated: PropTypes.bool,
  id: PropTypes.string,
  inputRef: PropTypes.func,
  isClickable: PropTypes.bool,
  isDisabled: PropTypes.bool,
  isReadOnly: PropTypes.bool,
  maxLength: PropTypes.string,
  name: PropTypes.string,
  needBorder: PropTypes.bool,
  needEffect: PropTypes.bool,
  needReadOnlyStyle: PropTypes.bool,
  onBlur: PropTypes.func,
  onChange: PropTypes.func,
  onClear: PropTypes.func,
  onClick: PropTypes.func,
  onFocus: PropTypes.func,
  onKeyDown: PropTypes.func,
  onKeyPress: PropTypes.func,
  onKeyUp: PropTypes.func,
  onMouseDown: PropTypes.func,
  placeHolder: PropTypes.string,
  showClearIcon: PropTypes.bool,
  size: PropTypes.oneOf(['small', 'xsmall', 'medium', 'xmedium']),
  title: PropTypes.func,
  type: PropTypes.oneOf(['text', 'password', 'number']),
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  variant: PropTypes.oneOf(['primary', 'secondary', 'default']),
  customClass: PropTypes.shape({
    customTBoxWrap: PropTypes.string,
    customTextBox: PropTypes.string,
    customTBoxIcon: PropTypes.string,
    customTBoxLine: PropTypes.string
  }),
  iconOnHover: PropTypes.bool,
  isFocus: PropTypes.bool,
  onClearMouseDown: PropTypes.func,
  customProps: PropTypes.shape({
    TextBoxProps: PropTypes.object
  })
};