import React from 'react';
import { defaultProps } from './props/defaultProps';
import { propTypes } from './props/propTypes';
import style from './semanticButton.module.css';
export default class Button extends React.Component {
  constructor(props) {
    super(props);
  }

  render() {
    const {
      value,
      type,
      text,
      title,
      name,
      autoFocus,
      disabled,
      ref,
      dataId,
      onClick,
      children,
      customClass,
      a11y
    } = this.props;
    let {
      ariaLabel,
      ariaHaspopup,
      ariaExpanded,
      ariaControls,
      ariaLabelledby
    } = a11y;
    return /*#__PURE__*/React.createElement("button", {
      className: `${style.buttonReset} ${customClass}`,
      "aria-label": ariaLabel,
      "aria-haspopup": ariaHaspopup,
      "aria-expanded": ariaExpanded,
      "aria-controls": ariaControls,
      "aria-labelledby": ariaLabelledby,
      type: type,
      value: value,
      name: name,
      autoFocus: autoFocus,
      disabled: disabled,
      ref: ref,
      "data-id": dataId,
      "data-test-id": dataId,
      onClick: onClick,
      "data-title": title
    }, children ? children : text);
  }

}
Button.defaultProps = defaultProps;
Button.propTypes = propTypes; // if (__DOCS__) {
//   Button.docs = {
//     componentGroup: 'semantic',
//     folderName: 'DefaultComponents'
//   };
// }