import React from 'react';
import { defaultProps } from '../../Buttongroup/props/defaultProps';
import { propTypes } from '../../Buttongroup/props/propTypes';
import style from '../../Buttongroup/Buttongroup.module.css';
export default function Buttongroup(props) {
  const {
    children,
    type,
    buttonPosition,
    customClass,
    dataId,
    dataSelectorId
  } = props;
  const btnGroup = [];
  children && children.forEach(child => {
    let btnRight = /*#__PURE__*/React.createElement("span", {
      className: style[type]
    }, child);
    btnGroup.push(btnRight);
  });
  return /*#__PURE__*/React.createElement("div", {
    className: `${style.buttonGroup} ${style[type]} ${customClass ? customClass : ''}`,
    "data-id": dataId,
    "data-test-id": dataId,
    "data-selector-id": dataSelectorId
  }, /*#__PURE__*/React.createElement("div", {
    className: style[`align${buttonPosition}`]
  }, children));
}
Buttongroup.defaultProps = defaultProps;
Buttongroup.propTypes = propTypes;