import React from 'react';
import { DropDown_propTypes, DropDownTarget_propTypes, DropDownContainer_propTypes, DropDownItemContainer_propTypes } from '../../DropDown/props/propTypes';
import { DropDownItemContainer_defaultProps } from '../../DropDown/props/defaultProps';
import style from '../../DropDown/DropDown.module.css';
import PopOver, { PopOverTarget, PopOverContainer } from '../PopOver/PopOver';
export default function DropDown(props) {
  let {
    children
  } = props;
  return /*#__PURE__*/React.createElement(PopOver, props, /*#__PURE__*/React.createElement(PopOverTarget, null, children[0]), /*#__PURE__*/React.createElement(PopOverContainer, null, children[1]));
}
DropDown.propTypes = DropDown_propTypes;
export function DropDownTarget(props) {
  let {
    children
  } = props;
  return /*#__PURE__*/React.createElement("div", null, children);
}
DropDownTarget.propTypes = DropDownTarget_propTypes;
export function DropDownContainer(props) {
  let {
    children
  } = props;
  return /*#__PURE__*/React.createElement("div", null, " ", children, " ");
}
DropDownContainer.propTypes = DropDownContainer_propTypes;
export function DropDownItemContainer(props) {
  let {
    children,
    dataId,
    getRef,
    onScroll
  } = props;

  function handleScroll(e) {
    onScroll && onScroll(e);
  }

  function getReference(ele) {
    getRef && getRef(ele);
  }

  return /*#__PURE__*/React.createElement("div", {
    className: style.listGroup,
    onScroll: handleScroll,
    ref: getReference,
    "data-id": dataId,
    "data-test-id": dataId
  }, children);
}
DropDownItemContainer.propTypes = DropDownItemContainer_propTypes;
DropDownItemContainer.defaultProps = DropDownItemContainer_defaultProps;