import React from 'react';
import { DropDownHeading_propTypes } from '../../DropDown/props/propTypes';
import { DropDownHeading_defaultProps } from '../../DropDown/props/defaultProps';
import style from '../../DropDown/DropDownHeading.module.css';
export default function DropDownHeading(props) {
  let {
    text,
    title = text,
    children,
    customClass,
    palette,
    htmlId,
    a11y,
    dataId,
    dataSelectorId
  } = props;
  let {
    role,
    ariaLabelledby,
    ariaLabel
  } = a11y;
  return /*#__PURE__*/React.createElement("div", {
    className: `${style[palette]} ${customClass}`,
    "data-title": title,
    role: role,
    "aria-labelledby": ariaLabelledby,
    "aria-label": ariaLabel,
    id: htmlId,
    "data-id": dataId,
    "data-test-id": dataId,
    "data-selector-id": dataSelectorId // tabindex='0'

  }, text, children);
}
DropDownHeading.propTypes = DropDownHeading_propTypes;
DropDownHeading.defaultProps = DropDownHeading_defaultProps;