import React from 'react';
import { defaultProps } from '../../Ribbon/props/defaultProps';
import { propTypes } from '../../Ribbon/props/propTypes';
import style from '../../Ribbon/Ribbon.module.css';
export default function Ribbon(props) {
  let {
    type,
    text,
    children,
    palette,
    size,
    dataId,
    customClass,
    dataSelectorId
  } = props;
  return /*#__PURE__*/React.createElement("span", {
    className: `${style.basic} ${customClass} ${type !== 'tag' ? type === 'plain' || type === 'box' || type === 'stamp' ? `${style[`plain_${palette}`]} 
                ${type === 'box' ? style[`box_${palette}`] : ''} ${type === 'stamp' ? style[`stamp_${palette}`] : ''}` : `${style[`palette_${palette}`]} ${type === 'default' ? style[`default_${palette}`] : ''}` : ''} ${style[size]} ${style[type]}`,
    "data-id": dataId,
    "data-test-id": dataId,
    "data-selector-id": dataSelectorId
  }, type === 'sticker' ? /*#__PURE__*/React.createElement("span", {
    className: style.after
  }) : null, children ? /*#__PURE__*/React.createElement("span", {
    className: style.children
  }, children) : null, /*#__PURE__*/React.createElement("span", {
    className: style.childText
  }, text), type === 'sticker' ? /*#__PURE__*/React.createElement("span", {
    className: style.before
  }) : null);
}
Ribbon.propTypes = propTypes;
Ribbon.defaultProps = defaultProps;