import React from 'react';
import { defaultProps } from '../../RippleEffect/props/defaultProps';
import { propTypes } from '../../RippleEffect/props/propTypes';
import CssProvider from '../../Provider/CssProvider';
import style from '../../RippleEffect/RippleEffect.module.css';
export default function RippleEffect(props) {
  let {
    children,
    isActive,
    isDisabled,
    palette,
    hoverType,
    isNeedEffect,
    needBorder,
    isCopyTextEnabled
  } = props;
  let className = isNeedEffect ? `${style.effect} ${style[palette]} ${needBorder ? style.border : ''} ${style[`${hoverType}Hover`] ? style[`${hoverType}Hover`] : ''} ${isActive && !isDisabled ? style.active : ''} ${isDisabled ? '' : style.hoverEffect} ${isCopyTextEnabled ? style.notAllowed : isDisabled ? CssProvider('isDisabled') : ''}` : '';
  let child = React.Children.only(children);
  return /*#__PURE__*/React.cloneElement(child, {
    className: `${child.props.className || ''} ${className}`
  });
}
RippleEffect.defaultProps = defaultProps;
RippleEffect.propTypes = propTypes;