import React from 'react';
import { defaultProps } from '../../../semantic/Button/props/defaultProps';
import { propTypes } from '../../../semantic/Button/props/propTypes';
import style from '../../../semantic/Button/semanticButton.module.css';
export default function Button(props) {
  const {
    value,
    type,
    text,
    title,
    name,
    autoFocus,
    disabled,
    ref,
    dataId,
    onClick,
    children,
    customClass,
    a11y
  } = props;
  let {
    ariaLabel,
    ariaHaspopup,
    ariaExpanded,
    ariaControls,
    ariaLabelledby
  } = a11y;
  return /*#__PURE__*/React.createElement("button", {
    className: `${style.buttonReset} ${customClass}`,
    "aria-label": ariaLabel,
    "aria-haspopup": ariaHaspopup,
    "aria-expanded": ariaExpanded,
    "aria-controls": ariaControls,
    "aria-labelledby": ariaLabelledby,
    type: type,
    value: value,
    name: name,
    autoFocus: autoFocus,
    disabled: disabled,
    ref: ref,
    "data-id": dataId,
    "data-test-id": dataId,
    onClick: onClick,
    "data-title": title
  }, children ? children : text);
}
Button.defaultProps = defaultProps;
Button.propTypes = propTypes; // if (__DOCS__) {
//   Button.docs = {
//     componentGroup: 'semantic',
//     folderName: 'DefaultComponents'
//   };
// }