"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _defaultProps = require("./props/defaultProps");

var _propTypes = require("./props/propTypes");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Accordion = /*#__PURE__*/function (_React$Component) {
  _inherits(Accordion, _React$Component);

  var _super = _createSuper(Accordion);

  function Accordion(props) {
    var _this;

    _classCallCheck(this, Accordion);

    _this = _super.call(this, props);
    _this.state = {
      selectedItem: _this.props.selectedItem
    };
    _this.selectMenu = _this.selectMenu.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Accordion, [{
    key: "selectMenu",
    value: function selectMenu(selectedItem) {
      var _this$props = this.props,
          onSelect = _this$props.onSelect,
          disableInternalState = _this$props.disableInternalState;

      if (onSelect) {
        onSelect(selectedItem);
      }

      !disableInternalState && this.setState({
        selectedItem: selectedItem
      });
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.selectedItem !== nextProps.selectedItem && !this.props.disableInternalState) {
        this.setState({
          selectedItem: nextProps.selectedItem
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          className = _this$props2.className,
          height = _this$props2.height,
          unMount = _this$props2.unMount,
          disableInternalState = _this$props2.disableInternalState,
          propSelectedItem = _this$props2.selectedItem,
          a11y = _this$props2.a11y,
          dataId = _this$props2.dataId,
          dataSelectorId = _this$props2.dataSelectorId;
      var selectedItem = this.state.selectedItem;

      var children = _react["default"].Children.map(this.props.children, function (child) {
        if (child) {
          return /*#__PURE__*/_react["default"].cloneElement(child, {
            selectedItem: disableInternalState ? propSelectedItem : selectedItem,
            selectMenu: _this2.selectMenu,
            unMount: unMount
          });
        }
      });

      var role = a11y.role,
          ariaExpanded = a11y.ariaExpanded,
          ariaHaspopup = a11y.ariaHaspopup;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: className ? className : '',
        style: {
          height: height
        },
        role: role,
        "aria-expanded": ariaExpanded,
        "aria-haspopup": ariaHaspopup,
        "data-id": dataId,
        "data-test-id": dataId,
        "data-selector-id": dataSelectorId
      }, children);
    }
  }]);

  return Accordion;
}(_react["default"].Component);

exports["default"] = Accordion;
Accordion.propTypes = _propTypes.Accordion_propTypes;
Accordion.defaultProps = _defaultProps.Accordion_defaultProps; // if (__DOCS__) {
//   Accordion.docs = {
//     componentGroup: 'Animation',
//     folderName: 'Style Guide'
//   };
// }