"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@testing-library/react");

var _Avatar = _interopRequireDefault(require("../Avatar.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe('Avatar', function () {
  test('rendering the defult props', function () {
    var _render = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], null)),
        asFragment = _render.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var palette = ['primary', 'secondary', 'info', 'default'];
  test.each(palette)('rendering the palette of- %s', function (palette) {
    var _render2 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      palette: palette
    })),
        asFragment = _render2.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var shape = ['circle', 'square'];
  test.each(shape)('rendering the shape of- %s', function (shape) {
    var _render3 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      shape: shape
    })),
        asFragment = _render3.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var size = ['xxsmall', 'small', 'xsmall', 'medium', 'xmedium', 'large', 'xlarge'];
  test.each(size)('rendering the size of- %s', function (size) {
    var _render4 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      size: size
    })),
        asFragment = _render4.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var textPalette = ['white', 'black'];
  test.each(textPalette)('rendering the size of- %s', function (textPalette) {
    var _render5 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      textPalette: textPalette
    })),
        asFragment = _render5.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering src', function () {
    var _render6 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      src: "https://www.w3schools.com/images/w3schools_green.jpg",
      name: "AvatarName"
    })),
        asFragment = _render6.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering Name in 2 Word', function () {
    var _render7 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      name: "Gowtham Kathirvel"
    })),
        asFragment = _render7.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering title', function () {
    var _render8 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      title: "AvatarNameTitile"
    })),
        asFragment = _render8.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering needTitle', function () {
    var _render9 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      needTitle: true,
      title: "AvatarNameTitile"
    })),
        asFragment = _render9.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering initial', function () {
    var _render10 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      initial: "AvatarTeam"
    })),
        asFragment = _render10.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering NeedBorder false', function () {
    var _render11 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      needBorder: false
    })),
        asFragment = _render11.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering BorderOnActive true', function () {
    var _render12 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      borderOnActive: true
    })),
        asFragment = _render12.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering borderOnHover true', function () {
    var _render13 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      borderOnHover: true
    })),
        asFragment = _render13.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering customClass true', function () {
    var _render14 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      customClass: "customClassAvatar"
    })),
        asFragment = _render14.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering alternateSrc', function () {
    var _render15 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      src: "https://www.w3schools.com/images/w3schools_green.jpg",
      showAlternateAvatar: true,
      alternateSrc: "https://www.w3schools.com/css/img_5terre.jpg"
    })),
        asFragment = _render15.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering showAlternateAvatar is enabled border get disabled', function () {
    var _render16 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      showAlternateAvatar: true,
      alternateSrc: "https://www.w3schools.com/css/img_5terre.jpg"
    })),
        asFragment = _render16.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering isAnimate is false', function () {
    var _render17 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      src: "https://www.w3schools.com/images/w3schools_green.jpg",
      isAnimate: false
    })),
        asFragment = _render17.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering needInnerBorder is true', function () {
    var _render18 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      src: "https://www.w3schools.com/images/w3schools_green.jpg",
      isAnimate: false,
      needInnerBorder: true
    })),
        asFragment = _render18.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering showDefaultBorder is true', function () {
    var _render19 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      src: "https://www.w3schools.com/images/w3schools_green.jpg",
      isInvalidImageList: false,
      needDefaultBorder: true
    })),
        asFragment = _render19.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the Custom props', function () {
    var _render20 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Avatar["default"], {
      customProps: {
        AvatarProps: {
          'data-avatar': true
        }
      }
    })),
        asFragment = _render20.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
});