"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@testing-library/react");

var _AvatarTeam = _interopRequireDefault(require("../AvatarTeam.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe('AvatarTeam', function () {
  test('rendering the defult props', function () {
    var _render = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AvatarTeam["default"], null)),
        asFragment = _render.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the Props of Avatar', function () {
    var _render2 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AvatarTeam["default"], {
      name: "AvatarTeamName",
      src: "https://www.w3schools.com/images/w3schools_green.jpg",
      title: "AvatarTeam",
      needTitle: true,
      borderOnActive: true,
      border: true,
      needInnerBorder: true,
      needBorder: true,
      needDefaultBorder: true
    })),
        asFragment = _render2.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var palettes = ['primary', 'secondary', 'info'];
  test.each(palettes)('rendering the palette of- %s', function (palette) {
    var _render3 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AvatarTeam["default"], {
      palette: palette
    })),
        asFragment = _render3.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var sizes = ['xxsmall', 'small', 'xsmall', 'medium', 'xmedium', 'large', 'xlarge'];
  test.each(sizes)('rendering the sizes of- %s', function (size) {
    var _render4 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AvatarTeam["default"], {
      size: size
    })),
        asFragment = _render4.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var textPalettes = ['white', 'black'];
  test.each(textPalettes)('rendering the textPalette of- %s', function (textPalette) {
    var _render5 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AvatarTeam["default"], {
      textPalette: textPalette
    })),
        asFragment = _render5.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering borderOnActive', function () {
    var _render6 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AvatarTeam["default"], {
      borderOnActive: true
    })),
        asFragment = _render6.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering border is true', function () {
    var _render7 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AvatarTeam["default"], {
      borderOnHover: true
    })),
        asFragment = _render7.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the onClick prop with asFragment and toMatchSnapshot', function () {
    // Define an onClick mock function
    var onClickMock = jest.fn(); // Render the Label component with the onClick prop

    var _render8 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AvatarTeam["default"], {
      onClick: onClickMock
    })),
        asFragment = _render8.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var palette = ['primary', 'secondary', 'info'];
  test.each(palette)('rendering the palette with isFilled of- %s', function (palette) {
    var _render9 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AvatarTeam["default"], {
      palette: palette,
      isFilled: true
    })),
        asFragment = _render9.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering CustomClass - customAvatar', function () {
    var _render10 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AvatarTeam["default"], {
      customClass: {
        customAvatar: 'TeamCustomClass'
      }
    })),
        asFragment = _render10.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering CustomClass - customAvatarTeam', function () {
    var _render11 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AvatarTeam["default"], {
      customClass: {
        customAvatarTeam: 'AvatarTeamCustomAvatar'
      }
    })),
        asFragment = _render11.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering customProps - AvatarTeamProps', function () {
    var _render12 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AvatarTeam["default"], {
      customProps: {
        AvatarTeamProps: {
          'data-team-avatar': true,
          isbold: 'Prakash the King maker'
        }
      }
    })),
        asFragment = _render12.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering customProps - AvatarProps', function () {
    var _render13 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AvatarTeam["default"], {
      src: "https://www.w3schools.com/images/w3schools_green.jpg",
      customProps: {
        AvatarProps: {
          size: 'small',
          isAnimate: false
        }
      }
    })),
        asFragment = _render13.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
});