"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Card_propTypes = exports.CardHeader_propTypes = exports.CardFooter_propTypes = exports.CardContent_propTypes = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var CardHeader_propTypes = {
  children: _propTypes["default"].element,
  dataId: _propTypes["default"].string,
  isScroll: _propTypes["default"].bool,
  customClass: _propTypes["default"].string,
  dataSelectorId: _propTypes["default"].string
};
exports.CardHeader_propTypes = CardHeader_propTypes;
var CardContent_propTypes = {
  children: _propTypes["default"].node,
  dataId: _propTypes["default"].string,
  eleRef: _propTypes["default"].func,
  isScrollAttribute: _propTypes["default"].bool,
  onScroll: _propTypes["default"].func,
  scroll: _propTypes["default"].oneOf(['vertical', 'horizontal', 'both', 'none']),
  shrink: _propTypes["default"].bool,
  customClass: _propTypes["default"].string,
  preventParentScroll: _propTypes["default"].oneOf(['vertical', 'horizontal', 'both']),
  dataSelectorId: _propTypes["default"].string
};
exports.CardContent_propTypes = CardContent_propTypes;
var Card_propTypes = {
  childTypes: _propTypes["default"].object,
  children: _propTypes["default"].node,
  dataId: _propTypes["default"].string,
  fetchData: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].bool]),
  from: _propTypes["default"].number,
  isScrollAttribute: _propTypes["default"].bool,
  // isScrollShadow: PropTypes.bool,
  limit: _propTypes["default"].number,
  noMoreData: _propTypes["default"].bool,
  noNeedUpScroll: _propTypes["default"].bool,
  onClick: _propTypes["default"].func,
  onScroll: _propTypes["default"].func,
  scrollAt: _propTypes["default"].string,
  customClass: _propTypes["default"].string,
  htmlId: _propTypes["default"].string,
  a11y: _propTypes["default"].shape({
    role: _propTypes["default"].string
  }),
  isPercentageScroll: _propTypes["default"].bool,
  eleRef: _propTypes["default"].func
};
exports.Card_propTypes = Card_propTypes;
var CardFooter_propTypes = {
  children: _propTypes["default"].node,
  customClass: _propTypes["default"].string,
  dataId: _propTypes["default"].string,
  dataSelectorId: _propTypes["default"].string
};
exports.CardFooter_propTypes = CardFooter_propTypes;