"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = DropBox;

var _react = _interopRequireWildcard(require("react"));

var _FocusScope = _interopRequireDefault(require("@zohodesk/a11y/es/FocusScope/FocusScope"));

var _Modal = _interopRequireDefault(require("../Modal/Modal"));

var _Config = require("../Provider/Config");

var _LibraryContextInit = _interopRequireDefault(require("../Provider/LibraryContextInit"));

var _cssJSLogic2 = _interopRequireDefault(require("./css/cssJSLogic"));

var _DropBoxElement = _interopRequireDefault(require("./DropBoxElement/DropBoxElement"));

var _defaultProps = require("./props/defaultProps");

var _propTypes = require("./props/propTypes");

var _Common = require("./../utils/Common");

var _DropBoxModule = _interopRequireDefault(require("./css/DropBox.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function DropBox(props) {
  var dropBoxRef = (0, _react.useRef)(null);
  var DropBoxContext = (0, _react.useContext)(_LibraryContextInit["default"]);
  var needResponsive = props.needResponsive,
      portalId = props.portalId,
      isActive = props.isActive,
      isAbsolutePositioningNeeded = props.isAbsolutePositioningNeeded,
      isRestrictScroll = props.isRestrictScroll,
      needFocusScope = props.needFocusScope,
      onClose = props.onClose,
      customProps = props.customProps;
  var _customProps$focusSco = customProps.focusScopeProps,
      focusScopeProps = _customProps$focusSco === void 0 ? {} : _customProps$focusSco;
  var _focusScopeProps$need = focusScopeProps.needAutoFocus,
      needAutoFocus = _focusScopeProps$need === void 0 ? true : _focusScopeProps$need,
      _focusScopeProps$need2 = focusScopeProps.needRestoreFocus,
      needRestoreFocus = _focusScopeProps$need2 === void 0 ? true : _focusScopeProps$need2,
      _focusScopeProps$need3 = focusScopeProps.needListNavigation,
      needListNavigation = _focusScopeProps$need3 === void 0 ? true : _focusScopeProps$need3,
      _focusScopeProps$need4 = focusScopeProps.needFocusLoop,
      needFocusLoop = _focusScopeProps$need4 === void 0 ? false : _focusScopeProps$need4,
      _focusScopeProps$need5 = focusScopeProps.needEnterAction,
      needEnterAction = _focusScopeProps$need5 === void 0 ? true : _focusScopeProps$need5;

  var _ref = DropBoxContext || {},
      direction = _ref.direction;

  var windowWidth,
      mobileWidth = (0, _Config.getLibraryConfig)('mobileWidth'),
      isModel = false;

  if (needResponsive) {
    windowWidth = window.innerWidth;

    if (windowWidth <= mobileWidth) {
      isModel = true;
    }
  }

  var _cssJSLogic = (0, _cssJSLogic2["default"])(props),
      zIndexStyle = _cssJSLogic.zIndexStyle;

  var dropBoxEle = needFocusScope ? /*#__PURE__*/_react["default"].createElement(_FocusScope["default"], _extends({
    onClose: onClose,
    elementRef: dropBoxRef,
    needAutoFocus: needAutoFocus,
    needRestoreFocus: needRestoreFocus,
    needListNavigation: needListNavigation,
    needFocusLoop: needFocusLoop,
    needEnterAction: needEnterAction
  }, focusScopeProps), /*#__PURE__*/_react["default"].createElement(_DropBoxElement["default"], _extends({
    isModel: isModel,
    direction: direction
  }, props, {
    zIndexStyle: zIndexStyle,
    subContainerRef: dropBoxRef
  }))) : /*#__PURE__*/_react["default"].createElement(_DropBoxElement["default"], _extends({
    isModel: isModel,
    subContainerRef: dropBoxRef,
    direction: direction
  }, props, {
    zIndexStyle: zIndexStyle
  }));
  return isModel && isActive ? /*#__PURE__*/_react["default"].createElement(_Modal["default"], {
    portalId: portalId
  }, /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(_DropBoxModule["default"].freezeLayer, " ").concat(_DropBoxModule["default"].freeze),
    style: zIndexStyle,
    onClick: _Common.stopPropagation
  }), dropBoxEle)) : !isAbsolutePositioningNeeded && isActive ? /*#__PURE__*/_react["default"].createElement(_Modal["default"], {
    portalId: portalId
  }, /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, isRestrictScroll ? /*#__PURE__*/_react["default"].createElement("div", {
    className: _DropBoxModule["default"].freezeLayer,
    style: zIndexStyle,
    onClick: _Common.stopPropagation
  }) : null, dropBoxEle)) : dropBoxEle;
}

DropBox.propTypes = _propTypes.DropBoxPropTypes;
DropBox.defaultProps = _defaultProps.DropBoxDefaultProps;