"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DropBoxElementPropTypes = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var DropBoxElementPropTypes = {
  animationStyle: _propTypes["default"].oneOf(['default', 'bounce', 'fadeIn', 'scaleIn']),
  arrowBottom: _propTypes["default"].number,
  arrowLeft: _propTypes["default"].number,
  arrowPosition: _propTypes["default"].oneOf(['start', 'mid', 'end']),
  arrowRight: _propTypes["default"].number,
  arrowTop: _propTypes["default"].number,
  bottom: _propTypes["default"].number,
  boxPosition: _propTypes["default"].oneOf(['bottomRight', 'bottomLeft', 'bottomCenter', 'topRight', 'topLeft', 'topCenter', 'rightTop', 'rightBottom', 'rightCenter', 'leftTop', 'leftBottom', 'leftCenter']),
  children: _propTypes["default"].element,
  dataId: _propTypes["default"].string,
  dataSelectorId: _propTypes["default"].string,
  forwardRef: _propTypes["default"].object,
  getRef: _propTypes["default"].func,
  isAbsolutePositioningNeeded: _propTypes["default"].bool,
  isActive: _propTypes["default"].bool,
  isAnimate: _propTypes["default"].bool,
  isArrow: _propTypes["default"].bool,
  isBoxPaddingNeed: _propTypes["default"].bool,
  isPadding: _propTypes["default"].bool,
  isRadius: _propTypes["default"].bool,
  left: _propTypes["default"].number,
  onClick: _propTypes["default"].func,
  right: _propTypes["default"].number,
  size: _propTypes["default"].oneOf(['mini', 'xmini', 'xsmall', 'small', 'medium', 'large', 'mlarge', 'xlarge', 'xxlarge', 'default']),
  top: _propTypes["default"].number,
  tourId: _propTypes["default"].string,
  htmlId: _propTypes["default"].string,
  tabIndex: _propTypes["default"].number,
  customClass: _propTypes["default"].shape({
    customDropBox: _propTypes["default"].string,
    customMobileDropBox: _propTypes["default"].string,
    customDropBoxWrap: _propTypes["default"].string,
    customMobileDropBoxWrap: _propTypes["default"].string
  }),
  a11y: _propTypes["default"].shape({
    role: _propTypes["default"].string,
    ariaMultiselectable: _propTypes["default"].bool,
    ariaLabelledby: _propTypes["default"].string
  }),
  palette: _propTypes["default"].oneOf(['default', 'dark']),
  customStyle: _propTypes["default"].object,
  customInlineStyle: _propTypes["default"].bool,
  isModel: _propTypes["default"].bool,
  direction: _propTypes["default"].string,
  positionsOffset: _propTypes["default"].object,
  targetOffset: _propTypes["default"].object,
  zIndexStyle: _propTypes["default"].object,
  subContainerRef: _propTypes["default"].func
};
exports.DropBoxElementPropTypes = DropBoxElementPropTypes;