"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = require("./props/propTypes");

var _defaultProps = require("./props/defaultProps");

var _Tag = _interopRequireDefault(require("../Tag/Tag"));

var _Layout = require("../Layout");

var _SelectedOptionsModule = _interopRequireDefault(require("./SelectedOptions.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/* eslint-disable react/forbid-component-props */
var SelectedOptions = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(SelectedOptions, _React$PureComponent);

  var _super = _createSuper(SelectedOptions);

  function SelectedOptions() {
    _classCallCheck(this, SelectedOptions);

    return _super.apply(this, arguments);
  }

  _createClass(SelectedOptions, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          selectedOptions = _this$props.selectedOptions,
          highLightedSelectOptions = _this$props.highLightedSelectOptions,
          isReadOnly = _this$props.isReadOnly,
          getRef = _this$props.getRef,
          onRemove = _this$props.onRemove,
          onSelect = _this$props.onSelect,
          size = _this$props.size,
          palette = _this$props.palette;
      var isDarkPalette = palette === 'dark' ? 'dark' : 'danger';
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, selectedOptions.map(function (option) {
        var id = option.id,
            value = option.value,
            photoURL = option.photoURL,
            icon = option.icon,
            optionType = option.optionType,
            iconSize = option.iconSize,
            isDisabled = option.isDisabled;
        var commonProps = {
          disabled: isDisabled,
          onRemove: isDisabled || isReadOnly ? null : onRemove,
          text: value,
          palette: isDarkPalette,
          onSelectTag: isReadOnly ? null : onSelect,
          getRef: getRef,
          initial: value,
          id: id,
          isReadOnly: isReadOnly
        };

        if (optionType === 'avatar') {
          return /*#__PURE__*/_react["default"].createElement(_Layout.Box, {
            className: "".concat(_SelectedOptionsModule["default"].tag, " ").concat(_SelectedOptionsModule["default"][size]),
            key: "".concat(id, "photoTag")
          }, /*#__PURE__*/_react["default"].createElement(_Tag["default"], _extends({}, commonProps, {
            active: highLightedSelectOptions.indexOf(id) >= 0,
            hasAvatar: true,
            imageURL: photoURL
          })));
        } else if (optionType === 'icon') {
          return /*#__PURE__*/_react["default"].createElement(_Layout.Box, {
            className: "".concat(_SelectedOptionsModule["default"].tag, " ").concat(_SelectedOptionsModule["default"][size]),
            key: "".concat(id, "iconTag")
          }, /*#__PURE__*/_react["default"].createElement(_Tag["default"], _extends({}, commonProps, {
            active: highLightedSelectOptions.indexOf(id) >= 0,
            iconName: icon,
            iconSize: iconSize
          })));
        }

        return /*#__PURE__*/_react["default"].createElement(_Layout.Box, {
          className: "".concat(_SelectedOptionsModule["default"].tag, " ").concat(_SelectedOptionsModule["default"][size]),
          key: "".concat(id, "tag")
        }, /*#__PURE__*/_react["default"].createElement(_Tag["default"], _extends({}, commonProps, {
          active: highLightedSelectOptions.indexOf(id) >= 0
        })));
      }));
    }
  }]);

  return SelectedOptions;
}(_react["default"].PureComponent);

exports["default"] = SelectedOptions;
SelectedOptions.propTypes = _propTypes.SelectedOptions_propTypes;
SelectedOptions.defaultProps = _defaultProps.SelectedOptions_defaultProps;