"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Suggestions_propTypes = exports.SelectedOptions_propTypes = exports.MultiSelect_propTypes = exports.MultiSelectWithAvatar_propTypes = exports.MultiSelectHeader_propTypes = exports.EmptyState_propTypes = exports.AdvancedMultiSelect_propTypes = exports.AdvancedGroupMultiSelect_propTypes = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var EmptyState_propTypes = {
  dataId: _propTypes["default"].string,
  emptyMessage: _propTypes["default"].string,
  getCustomEmptyState: _propTypes["default"].func,
  i18nKeys: _propTypes["default"].shape({
    loadingText: _propTypes["default"].string,
    emptyText: _propTypes["default"].string,
    noMoreText: _propTypes["default"].string,
    searchEmptyText: _propTypes["default"].string
  }),
  palette: _propTypes["default"].oneOf(['default', 'dark']),
  isLoading: _propTypes["default"].bool,
  noMoreOptionsMessage: _propTypes["default"].string,
  options: _propTypes["default"].array,
  searchEmptyMessage: _propTypes["default"].string,
  searchString: _propTypes["default"].string,
  suggestions: _propTypes["default"].array,
  htmlId: _propTypes["default"].string,
  a11y: _propTypes["default"].shape({
    role: _propTypes["default"].string
  })
};
exports.EmptyState_propTypes = EmptyState_propTypes;
var MultiSelect_propTypes = {
  animationStyle: _propTypes["default"].string,
  autoComplete: _propTypes["default"].bool,
  borderColor: _propTypes["default"].oneOf(['transparent', 'default', 'dark']),
  closePopupOnly: _propTypes["default"].func,
  dataId: _propTypes["default"].string,
  defaultDropBoxPosition: _propTypes["default"].oneOf(['bottom', 'top', 'left', 'right']),
  disableAction: _propTypes["default"].bool,
  dropBoxSize: _propTypes["default"].oneOf(['small', 'medium', 'large']),
  emptyMessage: _propTypes["default"].string.isRequired,
  getContainerRef: _propTypes["default"].func,
  getNextOptions: _propTypes["default"].func,
  getPublicMethods: _propTypes["default"].func,
  getRef: _propTypes["default"].func,
  getTargetRef: _propTypes["default"].func,
  i18nKeys: _propTypes["default"].shape({
    clearText: _propTypes["default"].string,
    loadingText: _propTypes["default"].string,
    emptyText: _propTypes["default"].string,
    noMoreText: _propTypes["default"].string,
    searchEmptyText: _propTypes["default"].string
  }),
  a11y: _propTypes["default"].shape({
    clearLabel: _propTypes["default"].string
  }),
  isAnimate: _propTypes["default"].bool,
  isBoxPaddingNeed: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool,
  isNextOptions: _propTypes["default"].bool,
  isPopupOpen: _propTypes["default"].bool,
  isPopupOpenOnEnter: _propTypes["default"].bool,
  isPopupReady: _propTypes["default"].bool,
  isReadOnly: _propTypes["default"].bool,
  isSearchClearOnClose: _propTypes["default"].bool,
  isSearching: _propTypes["default"].bool,
  needAutoFocus: _propTypes["default"].bool,
  needBorder: _propTypes["default"].bool,
  needLocalSearch: _propTypes["default"].bool,
  needResponsive: _propTypes["default"].bool,
  needToCloseOnSelect: _propTypes["default"].bool,
  //For Group multiSelect
  noMoreOptionsMessage: _propTypes["default"].string,
  onChange: _propTypes["default"].func.isRequired,
  onDropBoxClose: _propTypes["default"].func,
  onDropBoxOpen: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  onKeyDown: _propTypes["default"].func,
  onSearch: _propTypes["default"].func,
  openPopupOnly: _propTypes["default"].func,
  options: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number])), _propTypes["default"].arrayOf(_propTypes["default"].shape({
    id: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number])
  }))]).isRequired,
  palette: _propTypes["default"].oneOf(['default', 'dark']),
  placeHolder: _propTypes["default"].string,
  position: _propTypes["default"].string,
  prefixText: _propTypes["default"].string,
  removeClose: _propTypes["default"].func,
  searchDebounceTime: _propTypes["default"].number,
  searchEmptyMessage: _propTypes["default"].string,
  selectedOptions: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number])).isRequired,
  size: _propTypes["default"].oneOf(['medium', 'xmedium']),
  textBoxClass: _propTypes["default"].string,
  textBoxSize: _propTypes["default"].oneOf(['small', 'medium', 'xmedium']),
  textField: _propTypes["default"].string,
  title: _propTypes["default"].string,
  togglePopup: _propTypes["default"].func,
  valueField: _propTypes["default"].string,
  variant: _propTypes["default"].string,
  htmlId: _propTypes["default"].string,
  isSearchClearOnSelect: _propTypes["default"].bool,
  children: _propTypes["default"].node,
  customChildrenClass: _propTypes["default"].string,
  disabledOptions: _propTypes["default"].arrayOf(_propTypes["default"].string),
  getFooter: _propTypes["default"].func,
  needEffect: _propTypes["default"].bool,
  boxSize: _propTypes["default"].string,
  isLoading: _propTypes["default"].bool,
  dataSelectorId: _propTypes["default"].string,
  keepSelectedOptions: _propTypes["default"].bool,
  needSelectAll: _propTypes["default"].bool,
  selectAllText: _propTypes["default"].string,
  setAriaId: _propTypes["default"].string,
  ariaErrorId: _propTypes["default"].string
};
exports.MultiSelect_propTypes = MultiSelect_propTypes;
var MultiSelectHeader_propTypes = {
  dataId: _propTypes["default"].string,
  onSelect: _propTypes["default"].func,
  selectAllText: _propTypes["default"].string,
  suggestions: _propTypes["default"].array
};
exports.MultiSelectHeader_propTypes = MultiSelectHeader_propTypes;

var MultiSelectWithAvatar_propTypes = _objectSpread({
  options: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number])), _propTypes["default"].arrayOf(_propTypes["default"].shape({
    id: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    photoURL: _propTypes["default"].string
  }))]).isRequired,
  imageField: _propTypes["default"].string,
  customProps: _propTypes["default"].shape({
    SuggestionsProps: _propTypes["default"].object,
    DropBoxProps: _propTypes["default"].object
  })
}, MultiSelect_propTypes);

exports.MultiSelectWithAvatar_propTypes = MultiSelectWithAvatar_propTypes;
var SelectedOptions_propTypes = {
  getRef: _propTypes["default"].func,
  highLightedSelectOptions: _propTypes["default"].array,
  isReadOnly: _propTypes["default"].bool,
  onRemove: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  selectedOptions: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    id: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    photoURL: _propTypes["default"].string,
    logo: _propTypes["default"].string,
    optionType: _propTypes["default"].string
  })),
  size: _propTypes["default"].oneOf(['medium', 'xmedium']),
  palette: _propTypes["default"].string
};
exports.SelectedOptions_propTypes = SelectedOptions_propTypes;
var Suggestions_propTypes = {
  a11y: _propTypes["default"].shape({
    ariaParentRole: _propTypes["default"].string,
    ariaMultiselectable: _propTypes["default"].bool
  }),
  activeId: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  avatarPalette: _propTypes["default"].string,
  className: _propTypes["default"].string,
  dataId: _propTypes["default"].string,
  getRef: _propTypes["default"].func,
  hoverId: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  hoverOption: _propTypes["default"].number,
  listItemSize: _propTypes["default"].oneOf(['small', 'medium', 'large']),
  needBorder: _propTypes["default"].bool,
  needTick: _propTypes["default"].bool,
  onClick: _propTypes["default"].func,
  onMouseEnter: _propTypes["default"].func,
  palette: _propTypes["default"].string,
  selectedOptions: _propTypes["default"].array,
  htmlId: _propTypes["default"].string,
  suggestions: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    id: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    photoURL: _propTypes["default"].string,
    logo: _propTypes["default"].string,
    optionType: _propTypes["default"].string,
    listItemProps: _propTypes["default"].object
  }))
};
exports.Suggestions_propTypes = Suggestions_propTypes;

var AdvancedGroupMultiSelect_propTypes = _defineProperty({
  animationStyle: _propTypes["default"].string,
  autoComplete: _propTypes["default"].bool,
  borderColor: _propTypes["default"].oneOf(['transparent', 'default']),
  customClass: _propTypes["default"].string,
  dataId: _propTypes["default"].string,
  defaultDropBoxPosition: _propTypes["default"].oneOf(['bottom', 'top', 'left', 'right']),
  dropBoxSize: _propTypes["default"].oneOf(['small', 'medium', 'large']),
  emptyMessage: _propTypes["default"].string.isRequired,
  getContainerRef: _propTypes["default"].func,
  getFooter: _propTypes["default"].func,
  groupedOptions: _propTypes["default"].array.isRequired,
  i18nKeys: _propTypes["default"].shape({
    loadingText: _propTypes["default"].string,
    emptyText: _propTypes["default"].string,
    noMoreText: _propTypes["default"].string,
    searchEmptyText: _propTypes["default"].string
  }),
  a11y: _propTypes["default"].shape({
    clearLabel: _propTypes["default"].string
  }),
  isDataLoaded: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool,
  isPadding: _propTypes["default"].bool,
  isPopupOpen: _propTypes["default"].bool,
  isPopupReady: _propTypes["default"].bool,
  isReadOnly: _propTypes["default"].bool,
  listItemSize: _propTypes["default"].oneOf(['small', 'medium', 'large']),
  needBorder: _propTypes["default"].bool,
  needResponsive: _propTypes["default"].bool,
  needSelectAll: _propTypes["default"].bool,
  notifyPopupToggle: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  onKeyDown: _propTypes["default"].func,
  onSearch: _propTypes["default"].func,
  placeHolder: _propTypes["default"].string,
  position: _propTypes["default"].string,
  removeClose: _propTypes["default"].func,
  searchDebounceTime: _propTypes["default"].number,
  searchEmptyMessage: _propTypes["default"].string,
  selectAllText: _propTypes["default"].string,
  selectedGroupOptions: _propTypes["default"].array.isRequired,
  selectedOptionDetails: _propTypes["default"].object,
  size: _propTypes["default"].oneOf(['medium', 'xmedium']),
  textBoxSize: _propTypes["default"].oneOf(['small', 'medium', 'xmedium']),
  title: _propTypes["default"].string,
  variant: _propTypes["default"].string,
  htmlId: _propTypes["default"].string,
  isSearchClearOnSelect: _propTypes["default"].bool,
  palette: _propTypes["default"].oneOf(['default', 'dark']),
  needEffect: true,
  dataSelectorId: _propTypes["default"].string,
  valueField: _propTypes["default"].string,
  textField: _propTypes["default"].string,
  getTargetRef: _propTypes["default"].func,
  togglePopup: _propTypes["default"].func,
  needLocalSearch: _propTypes["default"].bool,
  isNextOptions: _propTypes["default"].bool,
  getNextOptions: _propTypes["default"].func,
  isPopupOpenOnEnter: _propTypes["default"].bool,
  onChange: _propTypes["default"].func,
  needToCloseOnSelect: _propTypes["default"].func,
  searchStr: _propTypes["default"].string,
  children: _propTypes["default"].node
}, "dataSelectorId", _propTypes["default"].string);

exports.AdvancedGroupMultiSelect_propTypes = AdvancedGroupMultiSelect_propTypes;

var AdvancedMultiSelect_propTypes = _objectSpread(_objectSpread({}, MultiSelect_propTypes), {}, {
  selectedOptionDetails: _propTypes["default"].string,
  iconSize: _propTypes["default"].string,
  id: _propTypes["default"].string.isRequired,
  options: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number])), _propTypes["default"].arrayOf(_propTypes["default"].shape({
    id: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    photoURL: _propTypes["default"].string
  }))]).isRequired,
  selectedOptions: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number])).isRequired,
  selectedOptionsLimit: _propTypes["default"].number,
  getSelectedOptionDetails: _propTypes["default"].func,
  emptyMessage: _propTypes["default"].string.isRequired,
  isDisabled: _propTypes["default"].bool,
  isReadOnly: _propTypes["default"].bool,
  needLocalSearch: _propTypes["default"].bool,
  needSelectAll: _propTypes["default"].bool,
  onChange: _propTypes["default"].func.isRequired,
  searchEmptyMessage: _propTypes["default"].string,
  placeHolder: _propTypes["default"].string,
  selectAllText: _propTypes["default"].string,
  textField: _propTypes["default"].string,
  valueField: _propTypes["default"].string,
  imageField: _propTypes["default"].string,
  iconName: _propTypes["default"].string,
  prefixText: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  //For grouping multiSelect
  optionType: _propTypes["default"].oneOf(['default', 'avatar', 'icon']),
  needEffect: _propTypes["default"].bool,
  animationStyle: _propTypes["default"].string,
  defaultDropBoxPosition: _propTypes["default"].oneOf(['bottom', 'top', 'left', 'right']),
  dropBoxSize: _propTypes["default"].oneOf(['small', 'medium', 'large']),
  isAnimate: _propTypes["default"].bool,
  size: _propTypes["default"].oneOf(['medium', 'xmedium']),
  textBoxSize: _propTypes["default"].oneOf(['small', 'medium', 'xmedium']),
  title: _propTypes["default"].string,
  variant: _propTypes["default"].string,
  dataIdClearIcon: _propTypes["default"].string,
  dataIdLoading: _propTypes["default"].string,
  dataIdMultiSelectComp: _propTypes["default"].string,
  dataIdSelectAllEle: _propTypes["default"].string,

  /**** Popup Props ****/
  isPopupOpen: _propTypes["default"].bool,
  isPopupReady: _propTypes["default"].bool,
  togglePopup: _propTypes["default"].func,
  getContainerRef: _propTypes["default"].func,
  position: _propTypes["default"].string,
  removeClose: _propTypes["default"].func,
  listItemSize: _propTypes["default"].oneOf(['small', 'medium', 'large']),
  needBorder: _propTypes["default"].bool,
  htmlId: _propTypes["default"].string,
  i18nKeys: _propTypes["default"].shape({
    clearText: _propTypes["default"].string,
    loadingText: _propTypes["default"].string,
    emptyText: _propTypes["default"].string,
    noMoreText: _propTypes["default"].string,
    searchEmptyText: _propTypes["default"].string
  }),
  a11y: _propTypes["default"].shape({
    clearLabel: _propTypes["default"].string
  }),
  borderColor: _propTypes["default"].oneOf(['transparent', 'default', 'dark']),
  isBoxPaddingNeed: _propTypes["default"].bool,
  isSearchClearOnSelect: _propTypes["default"].bool,
  disabledOptions: _propTypes["default"].arrayOf(_propTypes["default"].string),
  getFooter: _propTypes["default"].func,
  customProps: _propTypes["default"].shape({
    SuggestionsProps: _propTypes["default"].object,
    DropBoxProps: _propTypes["default"].object
  }),
  isLoading: _propTypes["default"].bool,
  dataSelectorId: _propTypes["default"].string
});

exports.AdvancedMultiSelect_propTypes = AdvancedMultiSelect_propTypes;