"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@testing-library/react");

var _Radio = _interopRequireDefault(require("../Radio.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe('Radio', function () {
  test('rendering the defult props', function () {
    var _render = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], null)),
        asFragment = _render.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the ID', function () {
    var _render2 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      id: "RadioID"
    })),
        asFragment = _render2.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the Name', function () {
    var _render3 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      name: "RadioName"
    })),
        asFragment = _render3.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the Value', function () {
    var _render4 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      value: "RadioValue"
    })),
        asFragment = _render4.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var palette = ['primary', 'danger'];
  test.each(palette)('rendering palette - %s', function (palette) {
    var _render5 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      palette: palette
    })),
        asFragment = _render5.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the Checked is true', function () {
    var _render6 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      palette: palette,
      active: true,
      text: "RadioText"
    })),
        asFragment = _render6.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the disabled is true', function () {
    var _render7 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      disabled: true,
      palette: palette,
      text: "RadioText"
    })),
        asFragment = _render7.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the isReadOnly is true', function () {
    var _render8 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      isReadOnly: true
    })),
        asFragment = _render8.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the disabledTitle', function () {
    var _render9 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      disabled: true,
      disabledTitle: "radioDisableTitle",
      text: "RadioText"
    })),
        asFragment = _render9.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the title', function () {
    var _render10 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      title: "radioTitle",
      text: "RadioText"
    })),
        asFragment = _render10.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the text', function () {
    var _render11 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      text: "RadioText"
    })),
        asFragment = _render11.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var labelPalette = ['default', 'primary', 'danger', 'mandatory'];
  test.each(labelPalette)('rendering labelPalette - %s', function (labelPalette) {
    var _render12 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      labelPalette: labelPalette,
      text: "RadioText"
    })),
        asFragment = _render12.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var size = ['small', 'medium'];
  test.each(size)('rendering size - %s', function (size) {
    var _render13 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      size: size
    })),
        asFragment = _render13.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var labelSize = ['small', 'medium', 'large'];
  test.each(labelSize)('rendering labelSize - %s', function (labelSize) {
    var _render14 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      labelSize: labelSize,
      text: "RadioText"
    })),
        asFragment = _render14.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var variant = ['primary', 'default'];
  test.each(variant)('rendering labelSize - %s', function (variant) {
    var _render15 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      variant: variant,
      text: "RadioText"
    })),
        asFragment = _render15.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(palette)('rendering the active is true - %s', function (palette) {
    var _render16 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      palette: palette,
      active: true,
      checked: true,
      text: "RadioText"
    })),
        asFragment = _render16.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the isFilled is false', function () {
    var _render17 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      isFilled: false
    })),
        asFragment = _render17.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the customClass of customRadioWrap,customRadio,customLabel ', function () {
    var _render18 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      customClass: {
        customRadioWrap: 'CustomClassCustomRadioWrap',
        customRadio: 'CustomClassCustomRadio',
        customLabel: 'CustomClassCustomLabel'
      },
      text: "RadioText"
    })),
        asFragment = _render18.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering ally ariaChecked true', function () {
    var _render19 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      checked: true
    })),
        asFragment = _render19.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering ally ariaHidden , ariaChecked, ariaReadonly fasle true', function () {
    var _render20 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      checked: true,
      isReadOnly: true,
      disabled: true,
      a11y: {
        ariaHidden: true,
        ariaChecked: true,
        ariaReadonly: true
      }
    })),
        asFragment = _render20.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering ally ariaHidden , ariaChecked, ariaReadonly is false', function () {
    var _render21 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      a11y: {
        ariaHidden: false
      }
    })),
        asFragment = _render21.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the accessMode when isReadOnly ', function () {
    var _render22 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      isReadOnly: true,
      text: "RadioText"
    })),
        asFragment = _render22.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the accessMode when disabled ', function () {
    var _render23 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      disabled: true,
      text: "RadioText"
    })),
        asFragment = _render23.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('eleRef prop is a function', function () {
    // Create a mock function
    var mockEleRef = jest.fn();

    var _render24 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      eleRef: mockEleRef
    })),
        asFragment = _render24.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('renders with different onClick props', function () {
    var onClickFunction = jest.fn();

    var _render25 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
      value: "radioValue",
      onChange: onClickFunction
    }))),
        asFragment = _render25.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
});