"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = shallowCompare;

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function isSame(a, b) {
  return a === b;
}

var hasOwnProperty = Object.prototype.hasOwnProperty;

function shallowCompare(objA, objB) {
  if (objA && objB && _typeof(objA) === 'object' && _typeof(objB) === 'object') {
    var keysA = Object.keys(objA);
    var keysB = Object.keys(objB);

    if (keysA.length !== keysB.length) {
      return false;
    } // Test for A's keys different from B.


    for (var _i = 0, _keysA = keysA; _i < _keysA.length; _i++) {
      var key = _keysA[_i];

      if (!hasOwnProperty.call(objB, key) || !isSame(objA[key], objB[key])) {
        return false;
      }
    }

    return true;
  }

  return isSame(objA, objB);
}