"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@testing-library/react");

var _Switch = _interopRequireDefault(require("../Switch"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe('Switch', function () {
  test('rendering the defult props', function () {
    var _render = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Switch["default"], null)),
        asFragment = _render.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the checked', function () {
    var _render2 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Switch["default"], {
      checked: true,
      id: "SwitchID"
    })),
        asFragment = _render2.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the dataId', function () {
    var _render3 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Switch["default"], {
      dataId: "data-Switch",
      id: "SwitchID"
    })),
        asFragment = _render3.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the disabled and disableTitle', function () {
    var _render4 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Switch["default"], {
      disabled: true,
      disableTitle: "data-disableTitle",
      id: "SwitchID"
    })),
        asFragment = _render4.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the text', function () {
    var _render5 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Switch["default"], {
      text: "SwitchText",
      id: "SwitchID"
    })),
        asFragment = _render5.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the ID', function () {
    var _render6 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Switch["default"], {
      id: "SwitchID",
      text: "SwitchText"
    })),
        asFragment = _render6.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the isReadOnly', function () {
    var _render7 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Switch["default"], {
      isReadOnly: true
    })),
        asFragment = _render7.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var size = ['small', 'medium'];
  test.each(size)('rendering the size of- %s', function (size) {
    var _render8 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Switch["default"], {
      size: size,
      id: "SwitchID"
    })),
        asFragment = _render8.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var labelSize = ['small', 'medium', 'large'];
  test.each(labelSize)('rendering the labelSize of- %s', function (labelSize) {
    var _render9 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Switch["default"], {
      text: "SwitchText",
      id: "SwitchID",
      labelSize: labelSize
    })),
        asFragment = _render9.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var labelPalette = ['default', 'primary', 'secondary', 'danger', 'mandatory'];
  test.each(labelPalette)('rendering the labelSize of- %s', function (labelPalette) {
    var _render10 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Switch["default"], {
      text: "SwitchText",
      id: "SwitchID",
      labelPalette: labelPalette
    })),
        asFragment = _render10.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the Name', function () {
    var _render11 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Switch["default"], {
      name: "LabelName",
      id: "SwitchID"
    })),
        asFragment = _render11.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the Title', function () {
    var _render12 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Switch["default"], {
      title: "LabelTitle",
      id: "SwitchID"
    })),
        asFragment = _render12.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the Value', function () {
    var _render13 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Switch["default"], {
      value: true,
      id: "SwitchID"
    })),
        asFragment = _render13.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the CustomClass', function () {
    var _render14 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Switch["default"], {
      text: "SwitchText",
      id: "SwitchID",
      customClass: {
        customSwitchWrap: 'SwtichCustomSwitchWrap',
        customSwitch: 'SwtichCustomSwitch',
        customSwitchSize: 'SwtichCustomSwitchSize',
        customLabel: 'SwtichCustomLabel'
      }
    })),
        asFragment = _render14.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the CustomProps', function () {
    var _render15 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Switch["default"], {
      text: "SwitchText",
      id: "SwitchID",
      customProps: {
        SwitchProps: {
          'data-switch': true
        },
        LabelProps: {
          title: 'SwtichTitle'
        }
      }
    })),
        asFragment = _render15.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
});