"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Tab;

var _react = _interopRequireWildcard(require("react"));

var _defaultProps = require("./props/defaultProps");

var _propTypes = require("./props/propTypes");

var _Layout = require("../Layout");

var _Common = require("../utils/Common");

var _TabModule = _interopRequireDefault(require("./Tab.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var tabTypes = {
  alpha: {
    active: 'alphaActive',
    tab: 'tabAlpha'
  },
  beta: {
    active: 'betaActive',
    tab: 'tabBeta'
  },
  delta: {
    active: 'deltaActive',
    tab: 'tabDelta'
  }
};

function Tab(_ref) {
  var id = _ref.id,
      style = _ref.style,
      text = _ref.text,
      children = _ref.children,
      className = _ref.className,
      dataId = _ref.dataId,
      dataSelectorId = _ref.dataSelectorId,
      title = _ref.title,
      titlePosition = _ref.titlePosition,
      activeClass = _ref.activeClass,
      href = _ref.href,
      isLink = _ref.isLink,
      isDisabled = _ref.isDisabled,
      tourId = _ref.tourId,
      onClick = _ref.onClick,
      isActive = _ref.isActive,
      getTabRef = _ref.getTabRef,
      onSelect = _ref.onSelect,
      type = _ref.type,
      isAnimate = _ref.isAnimate,
      needBorder = _ref.needBorder,
      needAppearance = _ref.needAppearance,
      align = _ref.align,
      isVirtual = _ref.isVirtual,
      customProps = _ref.customProps;
  var clickListener = (0, _react.useCallback)(function (event) {
    if (isLink && event && (event.metaKey || event.altKey || event.ctrlKey || event.shiftKey)) {
      event && event.stopPropagation();
      return;
    }

    event && event.preventDefault();
    onSelect(id);
    onClick && onClick(event);
  }, [id, isLink, onSelect, onClick]);
  var styleContent = (0, _react.useMemo)(function () {
    return tabTypes[type] || {
      active: 'active',
      tab: 'tab'
    };
  }, [type]);
  var getTab = (0, _react.useCallback)(function (ref) {
    return getTabRef && getTabRef(id, ref, isVirtual);
  }, [id, isVirtual]);
  var activeWithAppearance = (0, _Common.cs)([_TabModule["default"][styleContent.active], needBorder && !isAnimate && _TabModule["default"]["".concat(styleContent.active, "_border")]]);
  var activeClasses = (0, _Common.cs)([needAppearance && activeWithAppearance, activeClass]);
  var inActiveClasses = needAppearance && (0, _Common.cs)([_TabModule["default"][styleContent.tab], tabTypes[type] && _TabModule["default"]["".concat("".concat(type, "Hover"))]]);
  var tabClass = (0, _Common.cs)([_TabModule["default"].tab, align === 'vertical' ? _TabModule["default"].vertical : _TabModule["default"].horizontal, isDisabled && _TabModule["default"].disabled, needBorder && !isAnimate && needAppearance && _TabModule["default"].border, isActive ? activeClasses : inActiveClasses, className]);
  return /*#__PURE__*/_react["default"].createElement(_Layout.Box, _extends({
    tourId: tourId,
    tagName: isLink ? 'a' : 'div',
    className: tabClass,
    dataId: "".concat(dataId, "_Tab"),
    onClick: !isDisabled ? clickListener : undefined,
    style: style,
    eleRef: getTab,
    "data-title": title,
    "data-title-position": titlePosition,
    adjust: true,
    href: isLink ? href : undefined,
    "data-key": id,
    role: "link",
    "aria-controls": id,
    "aria-selected": isActive ? true : false,
    tabIndex: isLink ? undefined : isActive && !isDisabled ? '0' : '0',
    "aria-label": text ? text : null,
    dataSelectorId: dataSelectorId
  }, customProps), /*#__PURE__*/_react["default"].createElement(_Layout.Container, {
    alignBox: "row",
    align: "both",
    className: _TabModule["default"].textContainer
  }, text && /*#__PURE__*/_react["default"].createElement(_Layout.Box, {
    flexible: true,
    adjust: true,
    className: _TabModule["default"].tabText
  }, text), children ? /*#__PURE__*/_react["default"].createElement(_Layout.Box, {
    shrink: true
  }, children) : null));
}

Tab.defaultProps = _defaultProps.Tab_defaultProps;
Tab.propTypes = _propTypes.Tab_propTypes; // if (__DOCS__) {
//   Tab.docs = {
//     componentGroup: 'Tab',
//     folderName: 'Style Guide'
//   };
// }