"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.RefElement = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = require("./props/propTypes");

var _defaultProps = require("./props/defaultProps");

var _Modal = _interopRequireDefault(require("../../Modal/Modal"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var RefElement = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var Element = props.Element,
      elementProps = props.elementProps,
      renderChildren = props.renderChildren,
      _props$isChildrenRest = props.isChildrenRestrictionNeeded,
      isChildrenRestrictionNeeded = _props$isChildrenRest === void 0 ? true : _props$isChildrenRest,
      isActive = props.isActive;
  return isChildrenRestrictionNeeded ? isActive ? renderChildren ? renderChildren(ref) : /*#__PURE__*/_react["default"].createElement(Element, Object.assign({}, elementProps, {
    forwardRef: ref
  })) : null : renderChildren ? renderChildren(ref, isActive) : /*#__PURE__*/_react["default"].createElement(Element, Object.assign({}, elementProps, {
    isActive: isActive,
    forwardRef: ref
  }));
});

exports.RefElement = RefElement;
RefElement.propTypes = _propTypes.RefElement_propTypes;

var PortalLayer = /*#__PURE__*/function (_React$Component) {
  _inherits(PortalLayer, _React$Component);

  var _super = _createSuper(PortalLayer);

  function PortalLayer(props) {
    var _this;

    _classCallCheck(this, PortalLayer);

    _this = _super.call(this, props);
    _this.state = {
      isOpen: _this.props.initialState
    };
    _this.updateState = _this.updateState.bind(_assertThisInitialized(_this));
    _this.getState = _this.getState.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(PortalLayer, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var isActive = this.props.isActive,
          prevActive = prevProps.isActive;
      isActive = Boolean(isActive), prevActive = Boolean(prevActive);

      if (typeof isActive !== 'undefined' && isActive != prevActive && Boolean(this.state.isOpen) != isActive) {
        this.setState({
          isOpen: isActive
        });
      }
    }
  }, {
    key: "updateState",
    value: function updateState(alertState) {
      if (typeof alertState === 'boolean') {
        this.setState({
          isOpen: alertState
        });
      } else {
        this.setState(alertState);
      }
    }
  }, {
    key: "getState",
    value: function getState() {
      return Object.keys(this.state).length == 1 ? this.state.isOpen : this.state;
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          saveUpdateFunction = _this$props.saveUpdateFunction,
          saveGetFunction = _this$props.saveGetFunction,
          name = _this$props.name;
      saveUpdateFunction && saveUpdateFunction(this.updateState, name);
      saveGetFunction && saveGetFunction(this.getState, name);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          children = _this$props2.children,
          renderChildren = _this$props2.renderChildren,
          portalId = _this$props2.portalId,
          autoZIndexNeeded = _this$props2.autoZIndexNeeded,
          isChildrenRestrictionNeeded = _this$props2.isChildrenRestrictionNeeded,
          _this$state$isOpen = this.state.isOpen,
          isOpen = _this$state$isOpen === void 0 ? false : _this$state$isOpen;
      var Element = children && children.type,
          elementProps = children && children.props;
      return /*#__PURE__*/_react["default"].createElement(_Modal["default"], {
        autoZIndexNeeded: autoZIndexNeeded,
        portalId: portalId,
        isActive: isOpen
      }, /*#__PURE__*/_react["default"].createElement(RefElement, {
        Element: Element,
        elementProps: elementProps,
        renderChildren: renderChildren,
        isChildrenRestrictionNeeded: isChildrenRestrictionNeeded,
        isActive: isOpen
      }));
    }
  }]);

  return PortalLayer;
}(_react["default"].Component);

exports["default"] = PortalLayer;
PortalLayer.defaultProps = _defaultProps.defaultProps;
PortalLayer.propTypes = _propTypes.propTypes; // if (__DOCS__) {
//   PortalLayer.docs = {
//     componentGroup: 'Atom',
//     folderName: 'Style Guide'
//   };
// }