"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Accordion;

var _react = _interopRequireWildcard(require("react"));

var _hooks = require("@zohodesk/hooks");

var _defaultProps = require("../../Accordion/props/defaultProps");

var _propTypes = require("../../Accordion/props/propTypes");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function Accordion(props) {
  var className = props.className,
      height = props.height,
      unMount = props.unMount,
      disableInternalState = props.disableInternalState,
      propSelectedItem = props.selectedItem,
      a11y = props.a11y,
      dataId = props.dataId,
      dataSelectorId = props.dataSelectorId,
      onSelect = props.onSelect,
      children = props.children;
  var role = a11y.role,
      ariaExpanded = a11y.ariaExpanded,
      ariaHaspopup = a11y.ariaHaspopup;

  var _useState = (0, _react.useState)(propSelectedItem),
      _useState2 = _slicedToArray(_useState, 2),
      selectedItem = _useState2[0],
      setSelectedItem = _useState2[1];

  function selectMenu(selectedItem) {
    if (onSelect) {
      onSelect(selectedItem);
    }

    !disableInternalState && setSelectedItem(selectedItem);
  }

  (0, _hooks.useEffectCallOnlyAfterState)(function () {
    if (!disableInternalState) {
      setSelectedItem(propSelectedItem);
    }
  }, [propSelectedItem]);

  var renderChildren = _react["default"].Children.map(children, function (child) {
    if (child) {
      return /*#__PURE__*/_react["default"].cloneElement(child, {
        selectedItem: disableInternalState ? propSelectedItem : selectedItem,
        selectMenu: selectMenu,
        unMount: unMount
      });
    }
  });

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: className ? className : '',
    style: {
      height: height
    },
    role: role,
    "aria-expanded": ariaExpanded,
    "aria-haspopup": ariaHaspopup,
    "data-id": dataId,
    "data-test-id": dataId,
    "data-selector-id": dataSelectorId
  }, renderChildren);
}

Accordion.propTypes = _propTypes.Accordion_propTypes;
Accordion.defaultProps = _defaultProps.Accordion_defaultProps; // if (__DOCS__) {
//   Accordion.docs = {
//     componentGroup: 'Animation',
//     folderName: 'Style Guide'
//   };
// }