"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = AccordionItem;

var _react = _interopRequireDefault(require("react"));

var _defaultProps = require("../../Accordion/props/defaultProps");

var _propTypes = require("../../Accordion/props/propTypes");

var _VelocityAnimation = _interopRequireDefault(require("../VelocityAnimation/VelocityAnimation/VelocityAnimation"));

var _VelocityAnimationGroup = _interopRequireDefault(require("../VelocityAnimation/VelocityAnimationGroup/VelocityAnimationGroup"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function AccordionItem(props) {
  var id = props.id,
      selectMenu = props.selectMenu,
      className = props.className,
      children = props.children,
      dataId = props.dataId,
      dataSelectorId = props.dataSelectorId,
      unMount = props.unMount,
      unMountItem = props.unMountItem,
      a11y = props.a11y,
      innerClass = props.innerClass,
      equalityCheck = props.equalityCheck,
      selectedItem = props.selectedItem;
  unMountItem = unMountItem !== undefined ? unMountItem : unMount;
  var role = a11y.role;

  function equalityChecking() {
    return equalityCheck ? equalityCheck(id, selectedItem) : selectedItem == id;
  }

  function handleSelectMenu() {
    selectMenu(id);
  }

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: className ? className : '',
    "data-id": dataId,
    "data-test-id": dataId,
    role: role,
    "data-selector-id": dataSelectorId
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: innerClass ? innerClass : '',
    onClick: handleSelectMenu
  }, children[0]), unMountItem ? /*#__PURE__*/_react["default"].createElement(_VelocityAnimationGroup["default"], {
    name: "slideDown",
    isActive: equalityChecking()
  }, children[1]) : /*#__PURE__*/_react["default"].createElement(_VelocityAnimation["default"], {
    name: "slideDown",
    isActive: equalityChecking()
  }, children[1]));
}

AccordionItem.propTypes = _propTypes.AccordionItem_propTypes;
AccordionItem.defaultProps = _defaultProps.AccordionItem_defaultProps; // if (__DOCS__) {
//   AccordionItem.docs = {
//     componentGroup: 'Animation',
//     folderName: 'Style Guide'
//   };
// }