"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = AvatarTeam;

var _react = _interopRequireDefault(require("react"));

var _defaultProps = require("../../AvatarTeam/props/defaultProps");

var _propTypes = require("../../AvatarTeam/props/propTypes");

var _Avatar = _interopRequireDefault(require("../Avatar/Avatar"));

var _AvatarTeamModule = _interopRequireDefault(require("../../AvatarTeam/AvatarTeam.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

/* once avatar support firstname lastname and pattern
pass lastName as team name and pattern ["FIRST_NAME","LAST_NAME"] as props

Not going to export to external then can kept inside supportapp
*/
function AvatarTeam(props) {
  var src = props.src,
      name = props.name,
      size = props.size,
      palette = props.palette,
      textPalette = props.textPalette,
      onClick = props.onClick,
      title = props.title,
      isFilled = props.isFilled,
      dataId = props.dataId,
      needTitle = props.needTitle,
      customClass = props.customClass,
      borderOnActive = props.borderOnActive,
      borderOnHover = props.borderOnHover,
      dataSelectorId = props.dataSelectorId,
      customProps = props.customProps,
      needInnerBorder = props.needInnerBorder,
      needBorder = props.needBorder,
      needDefaultBorder = props.needDefaultBorder;
  var _customProps$AvatarTe = customProps.AvatarTeamProps,
      AvatarTeamProps = _customProps$AvatarTe === void 0 ? {} : _customProps$AvatarTe,
      _customProps$AvatarPr = customProps.AvatarProps,
      AvatarProps = _customProps$AvatarPr === void 0 ? {} : _customProps$AvatarPr;
  var _customClass$customAv = customClass.customAvatar,
      customAvatar = _customClass$customAv === void 0 ? '' : _customClass$customAv,
      _customClass$customAv2 = customClass.customAvatarTeam,
      customAvatarTeam = _customClass$customAv2 === void 0 ? '' : _customClass$customAv2;
  var border = borderOnHover || onClick;
  return /*#__PURE__*/_react["default"].createElement("span", _extends({
    className: "".concat(_AvatarTeamModule["default"].container, " ").concat(borderOnActive ? _AvatarTeamModule["default"].borderOnActive : border ? _AvatarTeamModule["default"].borderOnHover : '', " "),
    "data-id": dataId,
    "data-test-id": dataId,
    "data-selector-id": dataSelectorId
  }, AvatarTeamProps), /*#__PURE__*/_react["default"].createElement(_Avatar["default"], _extends({
    name: name,
    onClick: onClick,
    palette: palette,
    textPalette: textPalette,
    size: size,
    src: src,
    title: title,
    needTitle: needTitle,
    customClass: customAvatar,
    borderOnActive: borderOnActive,
    borderOnHover: border,
    needInnerBorder: needInnerBorder,
    needBorder: needBorder,
    needDefaultBorder: needDefaultBorder
  }, AvatarProps)), /*#__PURE__*/_react["default"].createElement("span", {
    className: "".concat(_AvatarTeamModule["default"].team, " ").concat(isFilled ? "".concat(_AvatarTeamModule["default"]["".concat(palette, "Filled")]) : _AvatarTeamModule["default"].nofill, " \n          ").concat(_AvatarTeamModule["default"]["".concat(size, "team")], " ").concat(customAvatarTeam)
  }));
}

AvatarTeam.defaultProps = _defaultProps.defaultProps;
AvatarTeam.propTypes = _propTypes.propTypes;