"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = DropDownHeading;

var _react = _interopRequireDefault(require("react"));

var _propTypes = require("../../DropDown/props/propTypes");

var _defaultProps = require("../../DropDown/props/defaultProps");

var _DropDownHeadingModule = _interopRequireDefault(require("../../DropDown/DropDownHeading.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function DropDownHeading(props) {
  var text = props.text,
      _props$title = props.title,
      title = _props$title === void 0 ? text : _props$title,
      children = props.children,
      customClass = props.customClass,
      palette = props.palette,
      htmlId = props.htmlId,
      a11y = props.a11y,
      dataId = props.dataId,
      dataSelectorId = props.dataSelectorId;
  var role = a11y.role,
      ariaLabelledby = a11y.ariaLabelledby,
      ariaLabel = a11y.ariaLabel;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(_DropDownHeadingModule["default"][palette], " ").concat(customClass),
    "data-title": title,
    role: role,
    "aria-labelledby": ariaLabelledby,
    "aria-label": ariaLabel,
    id: htmlId,
    "data-id": dataId,
    "data-test-id": dataId,
    "data-selector-id": dataSelectorId // tabindex='0'

  }, text, children);
}

DropDownHeading.propTypes = _propTypes.DropDownHeading_propTypes;
DropDownHeading.defaultProps = _defaultProps.DropDownHeading_defaultProps;