"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = DropDownSearch;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = require("../../DropDown/props/propTypes");

var _defaultProps = require("../../DropDown/props/defaultProps");

var _TextBox = _interopRequireDefault(require("../TextBox/TextBox"));

var _DropDownSearchModule = _interopRequireDefault(require("../../DropDown/DropDownSearch.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function DropDownSearch(props) {
  var name = props.name,
      id = props.id,
      maxLength = props.maxLength,
      onKeyDown = props.onKeyDown,
      onChange = props.onChange,
      value = props.value,
      onBlur = props.onBlur,
      size = props.size,
      textBoxSize = props.textBoxSize,
      placeHolder = props.placeHolder,
      customClass = props.customClass,
      getRef = props.getRef;
  var _customClass$searchCl = customClass.searchClass,
      searchClass = _customClass$searchCl === void 0 ? '' : _customClass$searchCl,
      _customClass$customTe = customClass.customTextBox,
      customTextBox = _customClass$customTe === void 0 ? '' : _customClass$customTe;
  var inputRef = (0, _react.useRef)(null); // eslint-disable-next-line func-call-spacing

  (0, _react.useEffect)(function () {
    inputRef.current && input.current.focus({
      preventScroll: true
    });
  }, []);

  function getReference(ele) {
    inputRef.current = ele;
    getRef && getRef(ele);
  }

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(_DropDownSearchModule["default"].search, " ").concat(_DropDownSearchModule["default"]["".concat(size, "Search")], " ").concat(searchClass)
  }, /*#__PURE__*/_react["default"].createElement(_TextBox["default"], {
    id: id,
    inputRef: getReference,
    maxLength: maxLength,
    name: name,
    onBlur: onBlur,
    onChange: onChange,
    onKeyDown: onKeyDown,
    size: textBoxSize,
    value: value,
    placeHolder: placeHolder,
    customClass: customTextBox
  }));
}

DropDownSearch.defaultProps = _defaultProps.DropDownSearch_defaultProps;
DropDownSearch.propTypes = _propTypes.DropDownSearch_propTypes;