"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Label;

var _react = _interopRequireDefault(require("react"));

var _defaultProps = require("../../Label/props/defaultProps");

var _propTypes = require("../../Label/props/propTypes");

var _LabelModule = _interopRequireDefault(require("../../Label/Label.module.css"));

var _LabelColorsModule = _interopRequireDefault(require("../../Label/LabelColors.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function Label(props) {
  var text = props.text,
      type = props.type,
      palette = props.palette,
      size = props.size,
      clipped = props.clipped,
      htmlFor = props.htmlFor,
      title = props.title,
      onClick = props.onClick,
      dataId = props.dataId,
      dataSelectorId = props.dataSelectorId,
      variant = props.variant,
      customClass = props.customClass,
      id = props.id,
      _props$a11y = props.a11y,
      a11y = _props$a11y === void 0 ? {} : _props$a11y;
  var tabIndex = a11y.tabIndex;
  return /*#__PURE__*/_react["default"].createElement("label", {
    className: "".concat(_LabelModule["default"].label, " ").concat(_LabelModule["default"][type], " ").concat(_LabelModule["default"][size], " ").concat(_LabelColorsModule["default"][palette], " ").concat(_LabelModule["default"]["font_".concat(variant)], "\n          ").concat(clipped ? _LabelModule["default"].dotted : '', " ").concat(onClick ? _LabelModule["default"].pointer : _LabelModule["default"].cursor, " ").concat(customClass, " "),
    htmlFor: htmlFor,
    "data-title": title,
    "data-id": dataId,
    "data-test-id": dataId,
    "data-selector-id": dataSelectorId,
    onClick: onClick,
    id: id,
    tabIndex: tabIndex
  }, text);
}

Label.defaultProps = _defaultProps.defaultProps;
Label.propTypes = _propTypes.propTypes;