"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Container;

var _react = _interopRequireDefault(require("react"));

var _propTypes = require("../../Layout/props/propTypes");

var _defaultProps = require("../../Layout/props/defaultProps");

var _utils = require("../../Layout/utils");

var _LayoutModule = _interopRequireDefault(require("../../Layout/Layout.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* eslint-disable  react/no-unused-prop-types*/
function getContainerClassNames(props) {
  var hidden = props.hidden,
      className = props.className,
      isInline = props.isInline,
      isCover = props.isCover,
      alignBox = props.alignBox,
      alignContent = props.alignContent,
      wrap = props.wrap,
      align = props.align,
      scroll = props.scroll,
      preventParentScroll = props.preventParentScroll;
  var modificators = [className];

  if (hidden) {
    hidden.forEach(function (key) {
      modificators.push((0, _utils.getClass)(_LayoutModule["default"], "hidden-screen-".concat(key)));
    });
  }

  if (isInline) {
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], 'inflex'));
  } else {
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], 'flex'));
  }

  if (isCover) {
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], 'cover'));
  }

  var alignBoxClassMapping = {
    row: 'rowdir',
    column: 'coldir',
    'row-reverse': 'rowReverse',
    'column-reverse': 'colReverse'
  };
  var alignClass = alignBoxClassMapping[alignBox];
  modificators.push((0, _utils.getClass)(_LayoutModule["default"], alignClass));

  if (alignContent) {
    var alignContentClassMapping = {
      start: 'alignStart',
      end: 'alignEnd',
      center: 'alignCenter',
      around: 'alignAround',
      between: 'alignBetween'
    };
    var alignContentClass = alignContentClassMapping[alignContent];
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], alignContentClass));
  }

  if (wrap) {
    var wrapClassMapping = {
      wrap: 'wrap',
      'wrap-reverse': 'wrapReverse'
    };
    var wrapClass = wrapClassMapping[wrap];
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], wrapClass));
  }

  if (align) {
    var alignClassMapping = {
      horizontal: 'hCenter',
      vertical: 'vCenter',
      both: 'both',
      between: 'between',
      around: 'around',
      right: 'right',
      left: 'left',
      top: 'top',
      bottom: 'bottom',
      baseline: 'baseline'
    };
    var _alignClass = alignClassMapping[align];
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], _alignClass));
  }

  if (scroll) {
    var scrollClassMapping = {
      horizontal: 'scrollx',
      vertical: 'scrolly',
      both: 'scrollboth',
      none: 'scrollnone'
    };
    var scrollClass = scrollClassMapping[scroll];
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], scrollClass));
  }

  if (preventParentScroll) {
    var ParentScrollClassMapping = {
      horizontal: 'preventScrollBubbleX',
      vertical: 'preventScrollBubbleY',
      both: 'preventScrollBubbleBoth'
    };
    var parentScrollClass = ParentScrollClassMapping[preventParentScroll];
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], parentScrollClass));
  }

  return modificators;
}

function getContainerProps(props) {
  return (0, _utils.createProps)(_propTypes.ContainerProps, props, getContainerClassNames(props));
}

function Container(props) {
  var tagName = props.tagName;
  var componentProps = (0, _utils.setProps)(_objectSpread({}, getContainerProps(props)), props, {
    isScrollAttribute: 'data-scroll',
    eleRef: 'ref',
    dataId: 'data-id',
    testId: 'data-test-id',
    tourId: 'data-tour',
    dataSelectorId: 'data-selector-id'
  });
  return /*#__PURE__*/_react["default"].createElement(tagName, componentProps);
}

Container.propTypes = _propTypes.ContainerProps;
Container.defaultProps = _defaultProps.ContainerDefaultProps;