"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getUniqueId = getUniqueId;
exports.removeGlobalIdPrefix = removeGlobalIdPrefix;
exports.setGlobalIdPrefix = setGlobalIdPrefix;
exports.useUniqueId = useUniqueId;

var _NumberGenerator = require("./NumberGenerator/NumberGenerator");

var _Config = require("./Config");

var globalId = (0, _Config.getLibraryConfig)('idCounter'),
    deletedIndexes = [],
    globalPrefix;

function setGlobalIdPrefix(value) {
  globalPrefix = value;
}

function removeGlobalIdPrefix() {
  globalPrefix = undefined;
}

function getGlobalIdPrefix() {
  return globalPrefix;
}

function setGlobalId(id) {
  globalId = id;
}

function getGlobalId() {
  return globalId;
}

function setDeletedIndexes(array) {
  deletedIndexes = array;
}

function getDeletedIndexes() {
  return deletedIndexes;
}

function callback(_ref) {
  var globalId = _ref.globalId,
      deletedIndexes = _ref.deletedIndexes;
  setGlobalId(globalId);
  setDeletedIndexes(deletedIndexes);
}

function useUniqueId(prefix) {
  return (0, _NumberGenerator.useNumberGenerator)({
    getGlobalId: getGlobalId,
    prefix: prefix,
    getGlobalPrefix: getGlobalIdPrefix,
    getDeletedIndexes: getDeletedIndexes,
    callback: callback
  });
}

function getUniqueId(Component, prefix) {
  return (0, _NumberGenerator.getNumberGenerators)({
    Component: Component,
    prefix: prefix,
    getGlobalPrefix: getGlobalIdPrefix,
    getGlobalId: getGlobalId,
    getDeletedIndexes: getDeletedIndexes,
    callback: callback
  });
} // let Provider = {
//   docs: {
//     componentGroup: 'Provider',
//     folderName: 'Functions'
//   }
// };
// export { Provider };