"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addGlobalId = addGlobalId;
exports.decreaseGlobalIds = decreaseGlobalIds;
exports.getNumberGenerators = getNumberGenerators;
exports.useNumberGenerator = useNumberGenerator;

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function addGlobalId(globalId) {
  if (Number.isSafeInteger(Number(globalId)) && Number.isSafeInteger(Number(globalId) + 1)) {
    globalId = Number(globalId) + 1;
  } else {
    globalId = "".concat(globalId, "1");
  }

  return globalId;
}

function decreaseGlobalId(number, globalId) {
  if ("".concat(number) == "".concat(globalId)) {
    if (Number.isSafeInteger(Number(globalId)) && Number.isSafeInteger(Number(globalId) - 1)) {
      globalId = Number(globalId) - 1;
    } else {
      globalId = "".concat(globalId);
      globalId = globalId.substring(0, globalId.length - 1);
    }

    return {
      isDeleted: true,
      globalId: globalId
    };
  }

  return {
    isDeleted: false,
    globalId: globalId
  };
}

function decreaseGlobalIds(numbers, deletedIndexes, globalId) {
  deletedIndexes = _toConsumableArray(deletedIndexes);

  _toConsumableArray(numbers).reverse().map(function (number) {
    var result = decreaseGlobalId(number, globalId);
    globalId = result.globalId;
    !result.isDeleted && deletedIndexes.push(number);
  });

  var _loop = function _loop() {
    var presentHighValue = globalId;
    var result = decreaseGlobalId(globalId, globalId);
    globalId = result.globalId;
    deletedIndexes = deletedIndexes.filter(function (ele) {
      return "".concat(ele) != "".concat(presentHighValue);
    });
  };

  for (; deletedIndexes.indexOf(globalId) != -1;) {
    _loop();
  }

  return {
    globalId: globalId,
    deletedIndexes: deletedIndexes
  };
}

function useNumberGenerator(_ref) {
  var getGlobalId = _ref.getGlobalId,
      prefix = _ref.prefix,
      getGlobalPrefix = _ref.getGlobalPrefix,
      getDeletedIndexes = _ref.getDeletedIndexes,
      callback = _ref.callback;
  var presentValues = (0, _react.useRef)([]),
      presentIndex = (0, _react.useRef)(0);
  prefix = typeof prefix === 'undefined' ? '' : "".concat(prefix, "_");
  var globalPrefix = typeof getGlobalPrefix() === 'undefined' ? '' : "".concat(getGlobalPrefix(), "_");

  function getNextId() {
    presentIndex.current = presentIndex.current + 1;
    var currentIndex = presentIndex.current;
    var isValuePresent = typeof presentValues.current[currentIndex] !== 'undefined';
    var result = isValuePresent ? presentValues.current[currentIndex] : presentValues.current[currentIndex] = addGlobalId(getGlobalId());
    !isValuePresent && callback({
      globalId: result,
      deletedIndexes: getDeletedIndexes()
    });
    return "".concat(globalPrefix).concat(prefix).concat(presentValues.current[currentIndex]);
  }

  (0, _react.useEffect)(function () {
    presentValues.current = presentValues.current.filter(function (value, index) {
      return index <= presentIndex.current;
    });
  });
  (0, _react.useEffect)(function () {
    return function () {
      callback(decreaseGlobalIds(presentValues.current, getDeletedIndexes(), getGlobalId()));
    };
  }, []);
  presentIndex.current = -1;
  return getNextId;
}

function getNumberGenerators(_ref2) {
  var Component = _ref2.Component,
      prefix = _ref2.prefix,
      getGlobalPrefix = _ref2.getGlobalPrefix,
      getGlobalId = _ref2.getGlobalId,
      getDeletedIndexes = _ref2.getDeletedIndexes,
      callback = _ref2.callback;
  var presentIndex = 0,
      presentValues = [],
      name = Component.props.name;
  var didUpdateRef = Component.componentDidUpdate ? Component.componentDidUpdate.bind(Component) : undefined,
      renderRef = Component.render.bind(Component),
      willUnMountRef = Component.componentWillUnmount ? Component.componentWillUnmount.bind(Component) : undefined;
  prefix = typeof prefix !== 'undefined' ? "".concat(prefix, "_") : '';

  Component.componentDidUpdate = function () {
    didUpdateRef && didUpdateRef.apply(void 0, arguments);
    presentValues = presentValues.filter(function (value, index) {
      return index <= presentIndex;
    });
  };

  Component.componentWillUnmount = function () {
    callback(decreaseGlobalIds(presentValues, getDeletedIndexes(), getGlobalId()));
    willUnMountRef && willUnMountRef();
    didUpdateRef = null, renderRef = null, willUnMountRef = null;
  };

  Component.render = function () {
    presentIndex = -1;
    return renderRef();
  };

  function getNextId() {
    presentIndex += 1;
    var isValuePresent = typeof presentValues[presentIndex] !== 'undefined';
    var result = isValuePresent ? presentValues[presentIndex] : presentValues[presentIndex] = addGlobalId(getGlobalId(getGlobalId()));
    var globalPrefix = getGlobalPrefix();
    globalPrefix = typeof globalPrefix === 'undefined' ? '' : "".concat(globalPrefix, "_");
    !isValuePresent && callback({
      globalId: result,
      deletedIndexes: getDeletedIndexes()
    });
    return "".concat(globalPrefix).concat(prefix).concat(result);
  }

  return getNextId;
}