"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Ribbon;

var _react = _interopRequireDefault(require("react"));

var _defaultProps = require("../../Ribbon/props/defaultProps");

var _propTypes = require("../../Ribbon/props/propTypes");

var _RibbonModule = _interopRequireDefault(require("../../Ribbon/Ribbon.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function Ribbon(props) {
  var type = props.type,
      text = props.text,
      children = props.children,
      palette = props.palette,
      size = props.size,
      dataId = props.dataId,
      customClass = props.customClass,
      dataSelectorId = props.dataSelectorId;
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "".concat(_RibbonModule["default"].basic, " ").concat(customClass, " ").concat(type !== 'tag' ? type === 'plain' || type === 'box' || type === 'stamp' ? "".concat(_RibbonModule["default"]["plain_".concat(palette)], " \n                ").concat(type === 'box' ? _RibbonModule["default"]["box_".concat(palette)] : '', " ").concat(type === 'stamp' ? _RibbonModule["default"]["stamp_".concat(palette)] : '') : "".concat(_RibbonModule["default"]["palette_".concat(palette)], " ").concat(type === 'default' ? _RibbonModule["default"]["default_".concat(palette)] : '') : '', " ").concat(_RibbonModule["default"][size], " ").concat(_RibbonModule["default"][type]),
    "data-id": dataId,
    "data-test-id": dataId,
    "data-selector-id": dataSelectorId
  }, type === 'sticker' ? /*#__PURE__*/_react["default"].createElement("span", {
    className: _RibbonModule["default"].after
  }) : null, children ? /*#__PURE__*/_react["default"].createElement("span", {
    className: _RibbonModule["default"].children
  }, children) : null, /*#__PURE__*/_react["default"].createElement("span", {
    className: _RibbonModule["default"].childText
  }, text), type === 'sticker' ? /*#__PURE__*/_react["default"].createElement("span", {
    className: _RibbonModule["default"].before
  }) : null);
}

Ribbon.propTypes = _propTypes.propTypes;
Ribbon.defaultProps = _defaultProps.defaultProps;