"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Textarea;

var _react = _interopRequireWildcard(require("react"));

var _defaultProps = require("../../Textarea/props/defaultProps");

var _propTypes = require("../../Textarea/props/propTypes");

var _TextareaModule = _interopRequireDefault(require("../../Textarea/Textarea.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function Textarea(props) {
  var size = props.size,
      placeHolder = props.placeHolder,
      needBorder = props.needBorder,
      text = props.text,
      isDisabled = props.isDisabled,
      resize = props.resize,
      maxLength = props.maxLength,
      animated = props.animated,
      variant = props.variant,
      getRef = props.getRef,
      onFocus = props.onFocus,
      dataId = props.dataId,
      dataSelectorId = props.dataSelectorId,
      isReadOnly = props.isReadOnly,
      needAppearance = props.needAppearance,
      needReadOnlyStyle = props.needReadOnlyStyle,
      borderColor = props.borderColor,
      needEffect = props.needEffect,
      autoFocus = props.autoFocus,
      htmlId = props.htmlId,
      a11y = props.a11y,
      customClass = props.customClass,
      onChange = props.onChange,
      onBlur = props.onBlur,
      onKeyDown = props.onKeyDown;
  var ariaLabel = a11y.ariaLabel,
      ariaLabelledby = a11y.ariaLabelledby;

  var handleChange = function handleChange(e) {
    e && e.preventDefault();
    onChange && onChange(e.target.value, e);
  };

  var handleBlur = function handleBlur(e) {
    e && e.preventDefault();
    onBlur && onBlur(e.target.value, e);
  };

  var handleKeyDown = function handleKeyDown(e) {
    onKeyDown && onKeyDown(e);
  };

  var resizes = (0, _react.useRef)({
    horizontal: 'resizeX',
    vertical: 'resizeY',
    both: 'resizeboth',
    none: 'noresize'
  });
  var options = (0, _react.useRef)({});

  if (isReadOnly) {
    options.current.readOnly = 'readOnly';
  }

  if (isDisabled) {
    options.current.disabled = 'disabled';
  }

  if (autoFocus) {
    options.current.autoFocus = true;
  }

  var classList = needAppearance ? "".concat(_TextareaModule["default"].container, " ").concat(_TextareaModule["default"][size], " ").concat(_TextareaModule["default"][variant], " ").concat(needBorder ? _TextareaModule["default"].needBorder : _TextareaModule["default"].noBorder, " ").concat(resize ? _TextareaModule["default"][resizes.current[resize]] : _TextareaModule["default"][resizes.current.none], "  ").concat(animated ? "".concat(_TextareaModule["default"]["".concat(size, "animated")]) : '', " ").concat(isDisabled && !needEffect || isReadOnly && !needEffect ? '' : _TextareaModule["default"].effect) : "".concat(_TextareaModule["default"].basic);
  return /*#__PURE__*/_react["default"].createElement("textarea", _extends({
    "aria-label": ariaLabel,
    "aria-labelledby": ariaLabelledby,
    className: "".concat(customClass, " ").concat(isReadOnly && needReadOnlyStyle ? _TextareaModule["default"].readonly : '', " ").concat(classList, " ").concat(_TextareaModule["default"]["borderColor_".concat(borderColor)]),
    placeholder: placeHolder
  }, options.current, {
    "data-id": dataId,
    "data-test-id": dataId,
    maxLength: maxLength,
    onChange: handleChange,
    onKeyDown: handleKeyDown,
    onFocus: onFocus,
    onBlur: handleBlur,
    ref: getRef,
    value: text,
    id: htmlId,
    "data-selector-id": dataSelectorId
  }));
}

Textarea.defaultProps = _defaultProps.defaultProps;
Textarea.propTypes = _propTypes.propTypes; // if (__DOCS__) {
//   Textarea.docs = {
//     componentGroup: 'Form Elements',
//     folderName: 'Style Guide',
//     external: true,
//     description: ' '
//   };
// }