"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = VelocityAnimationGroup;

var _react = _interopRequireWildcard(require("react"));

var _defaultProps = require("../../../VelocityAnimation/VelocityAnimationGroup/props/defaultProps");

var _propTypes = require("../../../VelocityAnimation/VelocityAnimationGroup/props/propTypes");

var _velocityReact = require("velocity-react");

require("velocity-animate/velocity.ui");

var _LibraryContextInit = _interopRequireDefault(require("../../../Provider/LibraryContextInit"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function clearProps(props) {
  var newProps = Object.assign({}, props);
  Object.keys(VelocityAnimationGroup.propTypes).forEach(function (key) {
    delete newProps[key];
  });
  return newProps;
}

function VelocityAnimationGroup(props) {
  var children = props.children,
      enterName = props.enterName,
      exitName = props.exitName,
      enterDuration = props.enterDuration,
      exitDuration = props.exitDuration,
      isActive = props.isActive,
      component = props.component,
      runOnMount = props.runOnMount,
      enterShowStyle = props.enterShowStyle,
      enterHideStyle = props.enterHideStyle,
      exitDelay = props.exitDelay,
      isFlex = props.isFlex,
      enterDelay = props.enterDelay,
      isCustomized = props.isCustomized,
      name = props.name,
      needUIPack = props.needUIPack;

  var _ref = (0, _react.useContext)(_LibraryContextInit["default"]) || {},
      direction = _ref.direction,
      isReducedMotion = _ref.isReducedMotion;

  var childProps = clearProps(props);
  var enterAnimationObj = {
    fade: 'transition.fadeIn',
    slideDown: 'slideDown',
    flyDown: {
      translateY: '0%'
    },
    slideRight: {
      translateX: '0%'
    },
    slideLeft: {
      translateX: '0%'
    },
    shrink: 'transition.shrinkIn',
    expand: 'transition.expandIn'
  };
  var exitAnimationObj = {
    fade: 'transition.fadeOut',
    slideDown: 'slideUp',
    flyDown: {
      translateY: '-100%'
    },
    slideRight: {
      translateX: direction == 'rtl' ? '-100%' : '100%'
    },
    slideLeft: {
      translateX: direction == 'rtl' ? '100%' : '-100%'
    },
    shrink: 'transition.shrinkOut',
    expand: 'transition.expandOut'
  };
  var enterAnimation = {
    animation: isCustomized ? enterAnimationObj[name] : needUIPack ? "transition.".concat(enterName, "In") : enterName,
    duration: !isReducedMotion ? enterDuration : 0,
    delay: enterDelay ? enterDelay : 0,
    display: isFlex ? 'flex' : ''
  };
  var exitAnimation = {
    animation: isCustomized ? exitAnimationObj[name] : needUIPack ? "transition.".concat(exitName ? exitName : enterName, "Out") : exitName ? exitName : enterName,
    duration: !isReducedMotion ? exitDuration : 0,
    delay: exitDelay ? exitDelay : 0,
    display: 'none'
  };
  return /*#__PURE__*/_react["default"].createElement(_velocityReact.VelocityTransitionGroup, _extends({
    enter: enterAnimation,
    leave: exitAnimation,
    component: component && component,
    runOnMount: runOnMount,
    enterHideStyle: enterHideStyle,
    enterShowStyle: enterShowStyle
  }, childProps), isActive ? children : null);
}

VelocityAnimationGroup.defaultProps = _objectSpread(_objectSpread({}, _defaultProps.defaultProps), {}, {
  component: _react["default"].Fragment
});
VelocityAnimationGroup.propTypes = _propTypes.propTypes; // if (__DOCS__) {
//   VelocityAnimationGroup.docs = {
//     componentGroup: 'Animation'
//   };
// }